<?php
/* NL/efg_firewall.inc
 *    PHP include script for efg.php,
 *    intended to show/deliver the actual firewall script
 *
 * 2014-03-22 v2.0.1 Added SYNACKANDNEW in bad_tcp_packets chain
 * 2014-03-18 v2.0.0 Released
 * 2014-02-27 v2.0.0 Started -AK
 *
 * TAB=3
 *
 * @category Net
 * @version $Id: NL/efg_firewall.inc, v2.0.1 2014-03-22
 * @author Alex KEMP http://www.modem-help.co.uk/
 *
 * (START original header)
 * Copyright 2002 Timothy Scott Morizot
 *
 * This file is part of my Easy Firewall Generator for IPTables.
 *
 * Easy Firewall Generator for IPTables is free software;
 * you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Easy Firewall Generator for IPTables is distributed
 * in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * in this distribution; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * (next line now set by Conteg)
 * //Set type to plain text
 * header("Content-Type: text/plain");
 * (FINISH original header)
 *
 * script transcribed to avoid use of untested '$_POST()' variables
 */

?>
#!/bin/sh
#
# Gegenereerd iptables firewall script voor de Linux 2.4, 2.6 + later kernel
<?php
	print "# Script gegenereerd door Easy Firewall Generator voor IPTables $VERSION
# (v2.0.0 rechtstreeks gebaseerd op oorspronkelijke EFG v1.17)
# Deze versie      : copyright $YEAR_NOW Modem-Help, Ltd. ($HOME)
# Vertaling (NL)   : copyright $YEAR_NOW Modem-Help, Ltd.
# Eerdere versies  : copyright 2002 Timothy Scott Morizot (easyfwgen.morizot.net)
#
# gegenereerde     : $NOW
";
?>
#
# Redhat chkconfig reacties - firewall vroeg toegepast,
#                             Verwijderd laat
# chkconfig: 2345 08 92
# beschrijving: Dit script is van toepassing of verwijdert iptables firewall regels
#
# Instellingen die worden gebruikt:
<?php
	print "# INET_IFACE: $INET_IFACE
# InternetIP: ". (( $DYNAMIC_IP )
	? $DYNAMIC_IP_YES_TITLE[ $_LANG ]
	: "{$DYNAMIC_IP_NO_TITLE[$_LANG]} ($INET_ADDRESS)"
) ."
#   Computer: ". (( $GATEWAY )
	? "{$GATEWAY_YES_TITLE[$_LANG]}
#             LOCAL_IFACE: $LOCAL_IFACE
#                LOCAL_IP: $LOCAL_IP
#               LOCAL_NET: $LOCAL_NET
#             LOCAL_BCAST: $LOCAL_BCAST"
	: $GATEWAY_NO_TITLE[ $_LANG ]
) ."
#    Netwerk: ". (( $SPECIAL_LAN )
	? (
		( $BLOCK_OUTBOUND )		? "({BLOCK_OUTBOUND_TITLE[$_LANG]})"		: '').
		(( $INTERNAL_DHCP )		? "({INTERNAL_DHCP_TITLE[$_LANG]})"			: '').
		(( $MANGLE_TTL )			? "({MANGLE_TTL_TITLE[$_LANG]})"				: '').
		(( $PORT_FORWARD )		? "({PORT_FORWARD_TITLE[$_LANG]})"			: '').
		(( $TRANSPARENT_PROXY )	? "({TRANSPARENT_PROXY_TITLE[$_LANG]})"	: ''
	)
	: '(geen)'
) ."
#    Laat in: ". (( $INBOUND_ALLOW )
	? (
		( $DHCP_IN )				? "({DHCP_IN_TITLE[$_LANG]})"					: '').
		(( $DNS_IN )				? "({DNS_IN_TITLE[$_LANG]})"					: '').
		(( $IM_IN )					? "({IM_IN_TITLE[$_LANG]})"					: '').
		(( $HTTP_IN )				? "({HTTP_IN_TITLE[$_LANG]})"					: '').
		(( $FTP_IN )				? "({FTP_IN_TITLE[$_LANG]})"					: '').
		(( $EMAIL_IN )				? "({EMAIL_IN_TITLE[$_LANG]})"				: '').
		(( $NTP_IN )				? "({NTP_IN_TITLE[$_LANG]})"					: '').
		(( $MDNSRESPONDER_IN )	? "({MDNSRESPONDER_IN_TITLE[$_LANG]})"		: '').
		(( $MESSENGER_IN )		? "({MESSENGER_IN_TITLE[$_LANG]})"			: '').
		(( $NFS_IN )				? "({NFS_IN_TITLE[$_LANG]})"					: '').
		(( $OTHER_IN )				? "({OTHER_IN_TITLE[$_LANG]})"				: '').
		(( $SSH_IN )				? "({SSH_IN_TITLE[$_LANG]})"					: ''
	)
	: '(geen)'
) ."
#  Fireparse: ". (( $LOG_FIREPARSE )
	? 'Ja'
	: 'Nee'
) ."
#   IRC User: ". (( $IRC_USER )
	? 'Ja'
	: 'Nee'
). "\n";
?>
#
# Deze generator is voornamelijk ontworpen voor RedHat installaties,
# hoewel aanpasbaar voor anderen zou moeten zijn.
#
# Het kan worden uitgevoerd met de typische start en stop argumenten.
# Indien gebruikt met stop, stopt na het spoelen van de firewall.
# Het opslaan en herstellen argumenten zal bewaren of herstellen van de regels
# uit het bestand /etc/sysconfig/iptables bestand. Het opslaan en herstellen
# argumenten zijn opgenomen om compatibiliteit te behouden met Redhat of Fedora
# init.d script als je liever om het te gebruiken.

# Redhat / Fedora / CentOS installatie-instructies
#
# 1. Hebben het systeem koppeling de iptables init.d startup script in rennen
#    staten 2, 3, en 5.
#    chkconfig --level 235 iptables on
#
# 2. Bewaar deze script en voer het uit om de regelset laden van dit bestand.
#    U kan nodig zijn om de opdracht uit te voeren dos2unix erop om
#    harde returns verwijderen.
#
# 3. Om het te laten passen bij het opstarten, dit script kopiëren naar
#    /etc/init.d/iptables. Het accepteert stoppen, starten, opslaan en argumenten
#    te herstellen. (Misschien wilt u de bestaande eerst op te slaan.)
#    Alternatief, als je uitgeven van de 'service iptables save' commando de
#    init.d script moet de regels opslaan en herladen hen tijdens de uitvoering.
#
# 4. Voor niet-Redhat systemen (of Redhat systemen als u een probleem hebt),
#    kunt u de opdracht wilt toevoegen aan dit script rc.local voeren. rc.local
#    bevindt zich meestal in /etc en /etc/rc.d en is meestal het laatste wat
#    uitgevoerd bij het opstarten. Voeg eenvoudig /pad/naar/script/script_name
#    op zijn eigen lijn in het rc.local bestand.

###############################################################################
#
# Local Settings
#

# sysctl locatie. Indien ingesteld, zal het gebruiken sysctl om de kernel
# parameters aan te passen. Als dit is ingesteld op de lege string (of is
# uitgeschakeld), het gebruik van sysctl is uitgeschakeld.

SYSCTL="/sbin/sysctl -w"

# Om de waarde direct in plaats echo naar de /proc
# SYSCTL=""

# IPTables Locatie - aan te passen indien nodig

IPT="/sbin/iptables"
IPTS="/sbin/iptables-save"
IPTR="/sbin/iptables-restore"

# Internet Interface
<?php
print "INET_IFACE=\"$INET_IFACE\"\n";
print ( $DYNAMIC_IP )
	? ''
	: "INET_ADDRESS=\"$INET_ADDRESS\"\n";
print ( $GATEWAY )
	? "
# Lokale Interface Informatie
LOCAL_IFACE=\"$LOCAL_IFACE\"
LOCAL_IP=\"$LOCAL_IP\"
LOCAL_NET=\"$LOCAL_NET\"
LOCAL_BCAST=\"$LOCAL_BCAST\"
"
	: '';
?>

# Localhost Interface

LO_IFACE="lo"
LO_IP="127.0.0.1"

# Opslaan ('save') en herstellen ('restore') argumenten hier behandeld
if [ "$1" = "save" ]
then
	echo -n "Besparing firewall /etc/sysconfig/iptables ... "
	$IPTS > /etc/sysconfig/iptables
	echo "gedaan"
	exit 0
elif [ "$1" = "restore" ]
then
	echo -n "Het herstellen firewall uit /etc/sysconfig/iptables ... "
	$IPTR < /etc/sysconfig/iptables
	echo "gedaan"
	exit 0
fi

###############################################################################
#
# Load Modules
#

echo "Kernel modules laden ..."

# Je moet de lijn hieronder verwijderd en voer het uit de eerste tijd alleen
# maar om ervoor te zorgen alle kernel module afhankelijkheden zijn OK. Het is
# niet nodig om elke keer lopen echter.

# /sbin/depmod -a

# Tenzij je kernel module auto-loading uitgeschakeld, moet u niet elk van deze
# modules handmatig laden. Anders dan ip_tables, ip_conntrack, en sommige van
# de optionele modules, heb ik deze links becommentarieerd standaard. Uncomment
# als je problemen hebt of als u een handicap module automatische toevoer.
# Merk op dat sommige modules door een andere kernel module moet worden geladen.

# kern netfilter module
/sbin/modprobe ip_tables

# de stateful connection tracking module
/sbin/modprobe ip_conntrack

# filter tafelmodule
# /sbin/modprobe iptable_filter

# mangel tafelmodule
# /sbin/modprobe iptable_mangle

# nat tafelmodule
# /sbin/modprobe iptable_nat

# LOG doelmodule
# /sbin/modprobe ipt_LOG

# Dit wordt gebruikt om het aantal pakketten per seconde / min / hr beperken
# /sbin/modprobe ipt_limit

# maskerade doelmodule
# /sbin/modprobe ipt_MASQUERADE

# filteren met eigenaar als onderdeel van de wedstrijd
# /sbin/modprobe ipt_owner

# REJECT doel laat de pakket en geeft een ICMP reactie.
# Het antwoord is configureerbaar. Standaard verbinding geweigerd.
# /sbin/modprobe ipt_REJECT

# Deze doelstelling maakt pakketten in de mangel tafel te worden gemarkeerd
# /sbin/modprobe ipt_mark

# Deze doelstelling betrekking op het TCP MSS
# /sbin/modprobe ipt_tcpmss

# Deze wedstrijd maakt het mogelijk meerdere poorten in plaats van een
# enkele poort of een bereik
# /sbin/modprobe multiport

# Deze wedstrijd controleert tegen de TCP vlaggen
# /sbin/modprobe ipt_state

# Deze wedstrijd vangt pakketten met ongeldige vlaggen
# /sbin/modprobe ipt_unclean

# De ftp nat module is vereist voor niet-PASV ftp support
<?php
	print ( $FTP_OUT )
		? '#'
		: '';
?>
/sbin/modprobe ip_nat_ftp

# de module voor volledige ftp verbindingen volgen
<?php
	print ( $FTP_OUT )
		? '#'
		: '';
?>
/sbin/modprobe ip_conntrack_ftp

# modulet fuld tilslutning sporing ftp
<?php
	print ( $IRC_OUT )
		? '#'
		: '';
?>
/sbin/modprobe ip_conntrack_irc


###############################################################################
#
# Kernel Parameterconfiguratie
#
# Zie http://ipsysctl-tutorial.frozentux.net/chunkyhtml/index.html voor een
# uitgebreide tutorial over sysctl en de diverse instellingen beschikbaar.

# Verplicht te IPv4 forwarding.
# Redhat gebruikers kunnen proberen de instelling FORWARD_IPV4 in
# /etc/sysconfig/network op true. Alternatief kan worden ingesteld in
# /etc/sysctl.conf
<?php
	print ( $GATEWAY )
		? "if [ \"\$SYSCTL\" = \"\" ]
then
    echo \"1\" > /proc/sys/net/ipv4/ip_forward
else
    \$SYSCTL net.ipv4.ip_forward=\"1\"
fi"
		: "#if [ \"\$SYSCTL\" = \"\" ]
#then
#    echo \"1\" > /proc/sys/net/ipv4/ip_forward
#else
#    \$SYSCTL net.ipv4.ip_forward=\"1\"
#fi";
?>


# Dit maakt dynamische adres hacken.
# Dit kan helpen als u een dynamisch IP-adres (bijv. slip, ppp, dhcp).
#if [ "$SYSCTL" = "" ]
#then
#    echo "1" > /proc/sys/net/ipv4/ip_dynaddr
#else
#    $SYSCTL net.ipv4.ip_dynaddr="1"
#fi

# Dit maakt SYN bescherming tegen overstromingen.
# De SYN cookies activering kunt u uw systeem een onbeperkt aantal
# TCP verbindingen te accepteren, terwijl nog steeds bezig om redelijke
# service te geven tijdens een denial of service-aanval.
if [ "$SYSCTL" = "" ]
then
    echo "1" > /proc/sys/net/ipv4/tcp_syncookies
else
    $SYSCTL net.ipv4.tcp_syncookies="1"
fi

# Dit maakt bron validatie door omgekeerde pad volgens RFC1812.
# Met andere woorden, het antwoordpakket uit dezelfde interface
# waarmee de bron pakket is verzonden? Het is aanbevolen voor
# singlehomed systemen en routers op stub netwerken. Aangezien
# dat zijn de configuraties deze firewall is ontworpen om te
# ondersteunen, zet ik het op standaard. Zet het uit als je meerdere
# netwerkkaarten aangesloten op hetzelfde netwerk te gebruiken.
if [ "$SYSCTL" = "" ]
then
    echo "1" > /proc/sys/net/ipv4/conf/all/rp_filter
else
    $SYSCTL net.ipv4.conf.all.rp_filter="1"
fi

# Deze optie kan een subnet worden firewall met een IP-adres.
# Het wordt gebruikt om een DMZ te bouwen. Want dat is niet een focus
# van deze firewall script, het is niet standaard ingeschakeld, maar zijn
# ter referentie opgenomen.
# Zie: http://www.sjdjweis.com/linux/proxyarp/
#if [ "$SYSCTL" = "" ]
#then
#    echo "1" > /proc/sys/net/ipv4/conf/all/proxy_arp
#else
#    $SYSCTL net.ipv4.conf.all.proxy_arp="1"
#fi

# De volgende kernel instellingen werden voorgesteld door Alex Weeks. Bedankt!

# Deze kernel parameter instrueert de kernel om alle ICMP echo requests
# verzonden naar het broadcast-adres negeren. Dit voorkomt een aantal
# smurfen en soortgelijke DoS vervelende aanvallen.
if [ "$SYSCTL" = "" ]
then
    echo "1" > /proc/sys/net/ipv4/icmp_echo_ignore_broadcasts
else
    $SYSCTL net.ipv4.icmp_echo_ignore_broadcasts="1"
fi

# Deze optie kan worden gebruikt om de bron geleid pakketten te accepteren
# of te weigeren. Het is meestal standaard ingeschakeld, maar wordt over het
# algemeen beschouwd als een veiligheidsrisico. Deze optie schakelt deze uit.
if [ "$SYSCTL" = "" ]
then
    echo "0" > /proc/sys/net/ipv4/conf/all/accept_source_route
else
    $SYSCTL net.ipv4.conf.all.accept_source_route="0"
fi

# Deze optie kan uitschakelen ICMP redirects. ICMP redirects worden over het
# algemeen beschouwd als een gevaar voor de veiligheid en moet niet nodig
# zijn door de meeste systemen met behulp van deze generator.
#if [ "$SYSCTL" = "" ]
#then
#    echo "0" > /proc/sys/net/ipv4/conf/all/accept_redirects
#else
#    $SYSCTL net.ipv4.conf.all.accept_redirects="0"
#fi

# Echter, zullen we zorgen voor de secure_redirects optie is op plaats.
# Deze optie accepteert alleen van gateways in de lijst standaardgateways.
if [ "$SYSCTL" = "" ]
then
    echo "1" > /proc/sys/net/ipv4/conf/all/secure_redirects
else
    $SYSCTL net.ipv4.conf.all.secure_redirects="1"
fi

# Deze optie logt pakketten van onmogelijk adressen.
if [ "$SYSCTL" = "" ]
then
    echo "1" > /proc/sys/net/ipv4/conf/all/log_martians
else
    $SYSCTL net.ipv4.conf.all.log_martians="1"
fi


###############################################################################
#
# Flush Bestaande Regels of Chains
#

echo "Vlissingen Tafels ..."

# Reset Default Policies
$IPT -P INPUT ACCEPT
$IPT -P FORWARD ACCEPT
$IPT -P OUTPUT ACCEPT
$IPT -t nat -P PREROUTING ACCEPT
$IPT -t nat -P POSTROUTING ACCEPT
$IPT -t nat -P OUTPUT ACCEPT
$IPT -t mangle -P PREROUTING ACCEPT
$IPT -t mangle -P OUTPUT ACCEPT

# Spoel alle regels
$IPT -F
$IPT -t nat -F
$IPT -t mangle -F

# Wis alle niet-standaard ketens
$IPT -X
$IPT -t nat -X
$IPT -t mangle -X

if [ "$1" = "stop" ]
then
	echo "Firewall volledig gespoeld! Draait nu zonder firewall."
	exit 0
fi

###############################################################################
#
# Regels Configuratie
#

###############################################################################
#
# Filter Tabel
#
###############################################################################

# Set Policies

$IPT -P INPUT DROP
$IPT -P OUTPUT DROP
$IPT -P FORWARD DROP

###############################################################################
#
# Gebruiker Opgegeven Chains
#
# Maak gebruiker kettingen om het aantal regels elk pakket moet doorkruisen
# verminderen..

echo "Maken en te vullen aangepaste lijn ketens ..."

# Maak een keten ongeldige pakketten filteren (INVALID)

$IPT -N bad_packets

# Maak nog een ketting om slechte TCP pakketten filteren

$IPT -N bad_tcp_packets

# Maak aparte kettingen voor icmp, tcp (inkomend en uitgaand), en inkomende
# UDP-pakketten.

$IPT -N icmp_packets

# Gebruikt voor UDP-pakketten inbound van het internet
$IPT -N udp_inbound

# Gebruikt om uitgaande UDP diensten blokkeren van interne netwerk
# Standaard om alle
$IPT -N udp_outbound

# Gebruikt om inkomende diensten mogelijk te maken indien gewenst
# Standaard fail behalve voor gevestigde sessies
$IPT -N tcp_inbound

# Gebruikt om uitgaande diensten te blokkeren van interne netwerk
# Standaard om alle
$IPT -N tcp_outbound

###############################################################################
#
# Bevolken Gebruiker Chains
#

# bad_packets keten
#
<?php
	// Rules for the private network
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $GATEWAY )
		? "
# Drop ontvangen pakketten op de externe interface
# beweert een bron van het lokale netwerk
\$IPT -A bad_packets -p ALL -i \$INET_IFACE -s \$LOCAL_NET -j LOG \
".		(( $LOG_FIREPARSE )
			? "    --log-prefix \"fp=bad_packets:2 a=DROP \""
			: "    --log-prefix \"Illegal source: \""
		). "

\$IPT -A bad_packets -p ALL -i \$INET_IFACE -s \$LOCAL_NET -j DROP
"
		: '';
?>

# Drop ongeldig (INVALID) pakketten onmiddellijk
$IPT -A bad_packets -p ALL -m state --state INVALID -j LOG \
<?php
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $LOG_FIREPARSE )
		? "    --log-prefix \"fp=bad_packets:1 a=DROP \""
		: "    --log-prefix \"Invalid packet: \"";
?>


$IPT -A bad_packets -p ALL -m state --state INVALID -j DROP

# Controleer dan de tcp-pakketten voor extra problemen
$IPT -A bad_packets -p tcp -j bad_tcp_packets

# Allemaal goed, dus rendement
$IPT -A bad_packets -p ALL -j RETURN

# bad_tcp_packets keten
#
# Alle TCP-pakketten zal deze keten doorkruisen.
# Elke nieuwe poging om verbinding te moeten beginnen met een SYN-pakket.
# Als dit niet gebeurt, is het waarschijnlijk een poortscan. Dit zakt
# pakketten in staat NEW die niet zijn gemarkeerd als syn pakketten.

<?php
	// If there is a gateway, exempt the internal interface.
	print ( $GATEWAY )
		? "
# Terug naar de roeping keten als de slechte pakketten afkomstig van de
# lokale interface. Dit blijft de benadering in deze firewall van een
# grotendeels vertrouwde interne netwerk.
\$IPT -A bad_tcp_packets -p tcp -i \$LOCAL_IFACE -j RETURN

# Echter, ik oorspronkelijk deed dit filter toepassen op de forward chain
# voor pakketten die van het interne netwerk. Terwijl ik niet definitief
# bepaald zijn effect, lijkt het interessant neveneffect van het blokkeren
# van bepaalde ad systemen. Blijkbaar een aantal ad-systemen hebben de browser
# begint een nieuwe verbinding die niet is gemarkeerd als een syn-pakket naar
# het imago van de advertentie te halen. Als u wenst te experimenteren verder
# commentaar de bovenstaande regel. Als je het probeert, wilt u wellicht ook
# de onderstaande regel uncommenten. Het zal die pakketjes te houden van wordt
# gelogd. Er zijn veel van hen.
#\$IPT -A bad_tcp_packets -p tcp -i \$LOCAL_IFACE ! --syn -m state \\
#     --state NEW -j DROP
"
		: '';
?>

# 2014-03-22 toegevoegd -AK
# Wet eervol ten behoeve van anderen ontvangen TCP Sequence Number Voorspelling
# aanvallen (deze aanvallen vertrouwen op de vervalste gastheer DROP onbekend
# SYN / ACK's in plaats van afwijzen).
# Zie http://iptables-tutorial.frozentux.net/iptables-tutorial.html#SYNACKANDNEW
$IPT -A bad_tcp_packets -p tcp --tcp-flags SYN,ACK SYN,ACK \
    -m state --state NEW -j REJECT --reject-with tcp-reset

# Fix iptables functie van het toestaan ??van nieuwe pakketten met SYN bit unset
# Zie http://iptables-tutorial.frozentux.net/iptables-tutorial.html#NEWNOTSYN
$IPT -A bad_tcp_packets -p tcp ! --syn -m state --state NEW -j LOG \
<?php
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $LOG_FIREPARSE )
		? "    --log-prefix \"fp=bad_tcp_packets:1 a=DROP \""
		: "    --log-prefix \"New not syn: \"";
?>

$IPT -A bad_tcp_packets -p tcp ! --syn -m state --state NEW -j DROP

$IPT -A bad_tcp_packets -p tcp --tcp-flags ALL NONE -j LOG \
<?php
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $LOG_FIREPARSE )
		? "    --log-prefix \"fp=bad_tcp_packets:2 a=DROP \""
		: "    --log-prefix \"Stealth scan: \"";
?>

$IPT -A bad_tcp_packets -p tcp --tcp-flags ALL NONE -j DROP

$IPT -A bad_tcp_packets -p tcp --tcp-flags ALL ALL -j LOG \
<?php
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $LOG_FIREPARSE )
		? "    --log-prefix \"fp=bad_tcp_packets:3 a=DROP \""
		: "    --log-prefix \"Stealth scan: \"";
?>

$IPT -A bad_tcp_packets -p tcp --tcp-flags ALL ALL -j DROP

$IPT -A bad_tcp_packets -p tcp --tcp-flags ALL FIN,URG,PSH -j LOG \
<?php
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $LOG_FIREPARSE )
		? "    --log-prefix \"fp=bad_tcp_packets:4 a=DROP \""
		: "    --log-prefix \"Stealth scan: \"";
?>

$IPT -A bad_tcp_packets -p tcp --tcp-flags ALL FIN,URG,PSH -j DROP

$IPT -A bad_tcp_packets -p tcp --tcp-flags ALL SYN,RST,ACK,FIN,URG -j LOG \
<?php
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $LOG_FIREPARSE )
		? "    --log-prefix \"fp=bad_tcp_packets:5 a=DROP \""
		: "    --log-prefix \"Stealth scan: \"";
?>

$IPT -A bad_tcp_packets -p tcp --tcp-flags ALL SYN,RST,ACK,FIN,URG -j DROP

$IPT -A bad_tcp_packets -p tcp --tcp-flags SYN,RST SYN,RST -j LOG \
<?php
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $LOG_FIREPARSE )
		? "    --log-prefix \"fp=bad_tcp_packets:6 a=DROP \""
		: "    --log-prefix \"Stealth scan: \"";
?>

$IPT -A bad_tcp_packets -p tcp --tcp-flags SYN,RST SYN,RST -j DROP

$IPT -A bad_tcp_packets -p tcp --tcp-flags SYN,FIN SYN,FIN -j LOG \
<?php
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $LOG_FIREPARSE )
		? "    --log-prefix \"fp=bad_tcp_packets:7 a=DROP \""
		: "    --log-prefix \"Stealth scan: \"";
?>

$IPT -A bad_tcp_packets -p tcp --tcp-flags SYN,FIN SYN,FIN -j DROP

# Allemaal goed, dus rendement
$IPT -A bad_tcp_packets -p tcp -j RETURN

# icmp_packets keten
#
# Deze ketting is alleen inkomende (van internet) ICMP pakketten.
# Type 8 (Echo Request) is standaard niet geaccepteerd. Inschakelen als u wilt
# hosts op afstand te kunnen om u te bereiken. 11 (overschreden) is de enige
# aanvaard dat zou al niet worden gedekt door de bestaande verbinding regel.
# Toegepast op INPUT op de externe interface.
#
# Zie: http://www.ee.siue.edu/~rwalden/networking/icmp.html
# voor meer informatie over ICMP types.
#
# Merk op dat de stateful instellingen kan antwoorden op ICMP-pakketten.
# Deze regels staan nieuwe pakketten van de gespecificeerde types.

# ICMP-pakketten moeten passen in een Layer 2 frame, dus moeten ze nooit
# worden gefragmenteerd. Gefragmenteerde ICMP-pakketten zijn een typisch
# teken van een denial of service-aanval.
$IPT -A icmp_packets --fragment -p ICMP -j LOG \
<?php
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $LOG_FIREPARSE )
		? "    --log-prefix \"fp=icmp_packets:1 a=DROP \""
		: "    --log-prefix \"ICMP Fragment: \"";
?>

$IPT -A icmp_packets --fragment -p ICMP -j DROP

# Echo; uncomment om uw systeem te worden gepingeld.
# Activeer het LOG commando als u ook wilt PING pogingen loggen
#
# $IPT -A icmp_packets -p ICMP -s 0/0 --icmp-type 8 -j LOG \
<?php
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $LOG_FIREPARSE )
		? "#    --log-prefix \"fp=icmp_packets:2 a=ACCEPT \""
		: "#    --log-prefix \"Ping detected: \"";
?>

# $IPT -A icmp_packets -p ICMP -s 0/0 --icmp-type 8 -j ACCEPT

# Standaard, echter, drop pings zonder houtkap. Blaster en andere wormen besmet
# systemen stralen pings. Commentaar van de lijn hieronder als u wilt pings
# ingelogd zijn, maar het zal waarschijnlijk je logs te vullen.
$IPT -A icmp_packets -p ICMP -s 0/0 --icmp-type 8 -j DROP

# Overschreden
$IPT -A icmp_packets -p ICMP -s 0/0 --icmp-type 11 -j ACCEPT

# Niet geëvenaard, zo terug dus het zal bewaard worden
$IPT -A icmp_packets -p ICMP -j RETURN

# TCP & UDP
# Identify ports at:
#    http://www.chebucto.ns.ca/~rakerman/port-table.html
#    http://www.iana.org/assignments/port-numbers

# udp_inbound keten
#
# Deze keten beschrijft de inkomende UDP-pakketten zal accepteren.
# Het is toegepast op INPUT op de externe of Internet-interface.
# Merk op dat de stateful instellingen kunt antwoorden.
# Deze regels zijn voor nieuwe aanvragen.
# Het zet netbios pakketten (Windows) onmiddellijk zonder houtkap.

# Drop netbios gesprekken
# Houd er rekening mee dat deze regels niet echt veranderen de manier waarop
# de firewall traktaties netbios verbindingen. Aansluitingen van de localhost
# en interne interface (indien aanwezig) worden standaard geaccepteerd.
# Reacties van het internet om verzoeken door of via de firewall worden ook
# standaard geaccepteerd. Om hier te komen, zou de pakketten moeten deel
# uitmaken van een nieuw verzoek van de Internet-interface ontvangen. U zou
# hebben om handmatig regels toe te voegen aan deze te aanvaarden. Ik deze
# regels toegevoegd omdat sommige netwerkverbindingen, zoals die via de kabel
# modems, meestal gevuld met geluidsoverlast van onbeschermde Windows-machines.
# Deze regels vallen die pakketjes snel en zonder in te loggen hen. Dit
# voorkomt dat ze het doorkruisen van de hele keten en houdt het logboek van
# het krijgen volgestopt met gebabbel van Windows-systemen.
$IPT -A udp_inbound -p UDP -s 0/0 --destination-port 137 -j DROP
$IPT -A udp_inbound -p UDP -s 0/0 --destination-port 138 -j DROP

<?php
	// Reject ident requests. IRC User
	print ( $IRC_USER )
		? "
# IRC Ident verzoeken (Port 113) moet een REJECT eerder regel dan de standaard
# DROP regel hebben. Dit is de minimale vereiste om lange vertragingen te
# vermijden tijdens het verbinden. Zie ook de tcp_inbound regel.
\$IPT -A udp_inbound -p UDP -s 0/0 --destination-port 113 -j REJECT

# Een meer geavanceerde configuratie zou de ident verzoeken accepteren.
#\$IPT -A udp_inbound -p UDP -s 0/0 --destination-port 113 -j ACCEPT
".		(( $GATEWAY )
			? "
# Echter, als dit een gateway systeem dat / nats maskerades voor interne
# systemen en de interne systemen wensen te chatten, een eenvoudig veranderen
# van deze regels op ACCEPT zal niet werken. De ident daemon op de gateway
# zal moeten weten hoe de verzoeken af ??te handelen. De voorraad daemon in de
# meeste Linux distributies kan dat niet doen. oidentd is een pakket dat kan.
# Zie: http://dev.ojnk.net/
"
			: ''
		)
		: '';

	// NTP server on gateway
	print ( $NTP_IN )
		? "
# Network Time Protocol (NTP) Server
\$IPT -A udp_inbound -p UDP -s 0/0 --destination-port 123 -j ACCEPT
"
		: '';

	// DNS Server - TCP (most are UDP, so this could be disabled)
	print ( $DNS_IN )
		? "
# DNS-server
# Instellen van de server op poort 53 te gebruiken als bron poort voor aanvragen.
# Opmerking: als u een alleen-caching nameserver die accepteert alleen
# verzoeken van het prive-netwerk of localhost uitgevoerd, kunt u commentaar uit
# deze lijn.
\$IPT -A udp_inbound -p UDP -s 0/0 --destination-port 53 -j ACCEPT

# Als je niet een query-source de server op poort 53 en je problemen hebt,
# uncomment deze regel. Het stelt specifiek reacties op query's gestart om een
# andere server vanaf een hoge UDP-poort. De stateful verbinding regels moeten
# deze situatie om te gaan, dat wel.
#\$IPT -A udp_inbound -p UDP -s 0/0 --source-port 53 -j ACCEPT
"
		: '';

	// mDNSResponder
	print ( $MDNSRESPONDER_IN )
		? "
# mDNSResponder
\$IPT -A udp_inbound -p UDP -s 0/0 --destination-port 5353 -j ACCEPT
"
		: '';

	// If running a DHCP server on the Internet interface, allow the requests
	print ( $DHCP_IN )
		? "
# Externe DHCP-server
# Toestaan ??DHCP client verzoek ingaande pakketten van externe netwerk
\$IPT -A udp_inbound -p UDP -s 0/0 --source-port 68 --destination-port 67 \\
     -j ACCEPT
"
		: '';
	// If it's a dynamic address, set rule to allow inbound DHCP
	print ( $DYNAMIC_IP )
		? "
# dynamische Adres
# Als DHCP, het eerste verzoek is een uitzending. De reactie niet exact
# overeenkomt met de inkomende pakketten. De volgende staat uitdrukkelijk
# de DHCP-poorten om dit probleem te verminderen. Als u uw dynamische adres
# ontvangen door een ander middel, kunt u waarschijnlijk deze lijn commentaar.
\$IPT -A udp_inbound -p UDP -s 0/0 --source-port 67 --destination-port 68 \\
     -j ACCEPT
"
		: '';

	// Inbound NFS selected
	print ( $NFS_IN )
		? "
# Network File System (NFS) Server
# Houd er rekening mee dat er extra diensten om een NFS-server ondersteunen
# door de firewall moet worden geconfigureerd. Lees de hulp bij de generator
# of door deze site:
# http://www.lowth.com/LinWiz/nfs_help.html

# NFS Server - portmapper
\$IPT -A udp_inbound -p UDP -s 0/0 --destination-port 111 -j ACCEPT

# NFS Server - statd
\$IPT -A udp_inbound -p UDP -s 0/0 --destination-port $STATD_PORT -j ACCEPT

# NFS Server - NFS daemon
\$IPT -A udp_inbound -p UDP -s 0/0 --destination-port 2049 -j ACCEPT

# NFS Server - lockd
\$IPT -A udp_inbound -p UDP -s 0/0 --destination-port $LOCKD_PORT -j ACCEPT

# NFS Server - mountd
\$IPT -A udp_inbound -p UDP -s 0/0 --destination-port $MOUNTD_PORT -j ACCEPT

# NFS Server - quotad
\$IPT -A udp_inbound -p UDP -s 0/0 --destination-port $RQUOTAD_PORT -j ACCEPT
"
		: '';

	// User specified inbound rule
	print ( $OTHER_IN and $OTHER_IN_UDP )
		? "
# Gebruiker opgegeven toegestaan UDP-protocol
\$IPT -A udp_inbound -p UDP -s 0/0 --destination-port $OTHER_IN_FROM".
(( empty( $OTHER_IN_TO )) ? '' : ":$OTHER_IN_TO")." -j ACCEPT
"
		: '';
?>

# Niet geëvenaard, dus terug voor het loggen
$IPT -A udp_inbound -p UDP -j RETURN

# udp_outbound keten
#
# Deze keten wordt gebruikt met een privenetwerk expeditie voor UDP verzoeken
# specifieke protocollen voorkomen. Toegepast op de FORWARD regel van het
# interne netwerk. Eindigt met een ACCEPT

<?php
	// If IM blocked, block ICQ, which uses UDP 4000
	print ( $IM_OUT )
		? "
# ICQ gebruikt UDP 4000 - Instant messaging geblokkeerd
\$IPT -A udp_outbound -p UDP -s 0/0 --destination-port 4000 -j REJECT
"
		: '';
?>

# Geen match, dus ACCEPT
$IPT -A udp_outbound -p UDP -s 0/0 -j ACCEPT

# tcp_inbound keten
#
# Deze ketting wordt gebruikt om inkomende verbindingen naar het
# systeem / gateway mogelijk. Gebruik in combinatie met zorg. Dit standaard
# op NONE. Het is van toepassing op de inbreng van de externe
# / Internet-interface.

<?php
	// Reject ident requests. IRC User
	print ( $IRC_USER )
		? "
# IRC Ident verzoeken (Port 113) moet een REJECT eerder regel dan de standaard
# DROP regel hebben. Dit is de minimale vereiste om lange vertragingen te
# vermijden tijdens het verbinden. Zie ook de udp_inbound regel.
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 113 -j REJECT

# Een meer geavanceerde configuratie zou de ident verzoeken accepteren.
#\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 113 -j ACCEPT
".		(( $GATEWAY )
			? "
# Echter, als dit een gateway systeem dat / nats maskerades voor interne
# systemen en de interne systemen wensen te chatten, een eenvoudig veranderen
# van deze regels op ACCEPT zal niet werken. De ident daemon op de gateway zal
# moeten weten hoe de verzoeken af ??te handelen. De voorraad daemon in de
# meeste Linux distributies kan dat niet doen. oidentd is een pakket dat kan.
# Zie: http://dev.ojnk.net/
"
			: ''
		)
		: '';

//DNS Server - TCP (most are UDP, so this could be disabled)
	print ( $DNS_IN )
		? "
# DNS Server - Laat TCP-verbindingen (zone transfers en grote verzoeken)
# Dit is standaard uitgeschakeld. DNS zone transfers plaatsvinden via TCP. Als
# u nodig hebt om de overdracht over het net wat je nodig hebt om deze lijn
# uncommenten toelaten. Als u vragen van de 'netto toe te staan, moet je ook
# bewust zijn dat, hoewel DNS-query's gebruiken UDP standaard, een afgeknotte
# UDP-query legaal kan worden via TCP in plaats daarvan ingediend. Je zult
# waarschijnlijk nooit nodig hebben, maar moeten zich bewust zijn van het feit.
# \$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 53 -j ACCEPT
"
		: '';

	// mDNSResponder
	print ( $MDNSRESPONDER_IN )
		? "
# mDNSResponder
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 5353 -j ACCEPT
"
		: '';

	// HTTP
	print ( $HTTP_IN )
		? "
# HTTP Web Server
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 80 -j ACCEPT
"
		: '';

	// HTTPS
	print ( $HTTPSSL_IN )
		? "
# HTTPS (Secure Web Server)
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 443 -j ACCEPT
"
		: '';

	if( $FTP_IN ) {
		// FTP
		print "
# FTP Server (Control)
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 21 -j ACCEPT

# FTP Client (Datapoort voor niet-PASV transfers)
\$IPT -A tcp_inbound -p TCP -s 0/0 --source-port 20 -j ACCEPT

# Passieve FTP
#
# Met passieve FTP, de server een poort aan de klant en kan de klant de
# verbinding in plaats van de inleiding van de verbinding met de klant van de
# data poort starten. Webbrowsers en klanten die achter een firewall gebruiken
# over het algemeen passieve ftp transfers. Een algemene doeleinden FTP-server
# zal moeten om hen te ondersteunen.
#
# Echter, door standaard een FTP-server zal een poort te selecteren uit het
# gehele assortiment van hoge poorten. Het is bijzonder veilig voor alle
# soorten poorten geopend. Gelukkig kan dat bereik worden beperkt. Deze
# firewall veronderstelt dat het bereik is beperkt tot een specifiek
# geselecteerde bereik. Dat bereik moet ook worden geconfigureerd in de ftp-server.
#
# Instructies voor het opgeven van het poortbereik voor de wu-ftpd server kan
# hier worden gevonden:
# http://www.wu-ftpd.org/man/ftpaccess.html
# (Zie de optie passieve poorten.)
#
# Instructies voor de ProFTPD server kan hier worden gevonden:
# http://proftpd.linux.co.uk/localsite/Userguide/linked/x861.html
";

		// Passive FTP
		print ( $PASSIVE_IN )
			? "
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port $PASSIVE_PORT_FROM:$PASSIVE_PORT_TO -j ACCEPT
"
			: "
# Voorbeeld regel
# \$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 62000:64000 -j ACCEPT
";
	}

	// Email
	print ( $EMAIL_IN )
		? "
# Email Server (SMTP)
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 25 -j ACCEPT

# Email Server (POP3)
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 110 -j ACCEPT

# Email Server (IMAP4)
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 143 -j ACCEPT
"
		: '';

	print ( $EMAILSSL_IN )
		? "
# SSL Email Server (POP3)
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 995 -j ACCEPT

# SSL Email Server (IMAP4)
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 993 -j ACCEPT
"
		: '';

	// SSH
	print ( $SSH_IN )
		? "
# SSH
# MH hulp: zoals geleverd, de volgende regel laat ssh verbindingen vanuit elke
# bron ('-s 0/0'). Dat zal leiden tot honderden dagelijkse verbindingen van
# IP-adressen proberen dictionary-aanvallen op uw apparaat. Indien mogelijk,
# wordt u sterk aangeraden uw eigen IP / CIDR te plaatsen in plaats:
# bijv. '-s \$MY_IP' of '-s \$MY_CIDR'.
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 22 -j ACCEPT
"
		: '';

	// ICQ
	print ( $IM_IN )
		? "
# ICQ File Transfers en andere geavanceerde functies
#
# ICQ ondersteunt een aantal opties dan eenvoudige instant messaging. Voor
# degenen die wilt gebruiken, moet het systeem voor instant messaging nieuwe
# verbindingen geïnitieerd vanuit externe systemen mogelijk te maken. Deze
# optie zal een opgegeven poortbereik openen op de firewall systeem. De
# ICQ-client op de firewall systeem moet ook worden geconfigureerd om de
# opgegeven poort range gebruiken.
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port $IM_PORT_FROM:$IM_PORT_TO -j ACCEPT
"
		: '';

	// MSN Messenger
	print ( $MESSENGER_IN )
		? "
# MSN Messenger File Transfers
#
# Messenger ondersteunt bestandsoverdracht. Voor overschrijvingen geïnitieerd
# door externe systemen wilt gebruiken, moet het systeem nieuwe verbindingen
# geïnitieerd van systemen op afstand een specifieke poort bereik accepteren.
# Deze optie staat standaard op de haven bereik 6891 tot 6900. Tenzij de MSN
# Messenger-client kan worden geconfigureerd voor elk poortbereik opgeven,
# niet de standaardinstelling wijzigen.
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port $MSN_PORT_FROM:$MSN_PORT_TO -j ACCEPT
"
		: '';

	// Inbound NFS selected
	print ( $NFS_IN )
		? "
# Network File System (NFS) Server
#
# Houd er rekening mee dat er extra diensten om een NFS-server ondersteunen
# door de firewall moet worden geconfigureerd. Lees de hulp bij de generator
# of door deze site:
# http://www.lowth.com/LinWiz/nfs_help.html

# NFS Server - portmapper
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 111 -j ACCEPT

# NFS Server - statd
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port $STATD_PORT -j ACCEPT

# NFS Server - NFS daemon
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 2049 -j ACCEPT

# NFS Server - lockd
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port $LOCKD_PORT -j ACCEPT

# NFS Server - mountd
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port $MOUNTD_PORT -j ACCEPT

# NFS Server - quotad
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port $RQUOTAD_PORT -j ACCEPT
"
		: '';

	// User specified inbound rule
	print ( $OTHER_IN and $OTHER_IN_TCP )
		? "
# Gebruiker opgegeven toegestaan TCP-protocol
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port  $OTHER_IN_FROM".
(( empty( $OTHER_IN_TO )) ? '' : ":$OTHER_IN_TO")." -j ACCEPT
"
		: '';
?>

# Niet geëvenaard, zo terug dus het zal bewaard worden
$IPT -A tcp_inbound -p TCP -j RETURN

# tcp_outbound keten
#
# Deze keten wordt gebruikt met een privenetwerk expeditie voorkomen verzoeken
# specifieke protocollen. Toegepast op de FORWARD regel van het interne netwerk.
# Eindigt met een ACCEPT

<?php
	// IRC
	print ( $IRC_OUT )
		? "
# Blok IRC
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 194 -j REJECT
"
		: '';

	// telnet
	print ( $TELNET_OUT )
		? "
# Blok Outbound Telnet
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 23 -j REJECT
"
		: '';

	// ssh
	print ( $SSH_OUT )
		? "
# Blok SSH
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 22 -j REJECT
"
		: '';

	// usenet
	print ( $NEWS_OUT )
		? "
# Blok Usenet Access
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 119 -j REJECT
"
		: '';

	// web
	print ( $HTTP_OUT )
		? "
# Blok Web Access
# HTTP
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 80 -j REJECT

# HTTPS (Secure Web)
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 443 -j REJECT
"
		: '';

	// ftp
	print ( $FTP_OUT )
		? "
# Blok FTP Access
# Control
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 21 -j REJECT

# Data
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 20 -j REJECT
"
		: '';

	// Instant Messaging
	print ( $IM_OUT )
		? "
# Blok Instant Messaging
# AIM
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 5190 -j REJECT

# AIM Images
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 4443 -j REJECT

# MSN Messenger
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 1863 -j REJECT
"
		: '';

	// Instant Messaging
	print ( $EMAIL_OUT )
		? "
# Blokkeer e-mail toegang tot externe servers
# SMTP
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 25 -j REJECT

# POP3
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 110 -j REJECT

# IMAP4
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 143 -j REJECT
"
		: '';
?>

# Geen match, dus ACCEPT
$IPT -A tcp_outbound -p TCP -s 0/0 -j ACCEPT

###############################################################################
#
# INPUT Keten
#

echo "Proces INPUT keten ..."

# Laat alles op localhost-interface
$IPT -A INPUT -p ALL -i $LO_IFACE -j ACCEPT

# Drop slecht pakketten
$IPT -A INPUT -p ALL -j bad_packets

# DOCSIS conforme kabelmodems
# Sommige DOCSIS-compatibele kabel modems sturen IGMP multicast naar andere
# computers te vinden. De multicast-pakketten hebben de bestemming adres
# 224.0.0.1. Je kunt ze accepteren. Als u ervoor kiest om dit te doen,
# uncomment de regel te aanvaarden en commentaar van de regel om hen te laten
# vallen De firewall zal ze hier langskomen standaard om te voorkomen
# verrommeling het logboek. De firewall zal alle multicasts dalen tot het hele
# subnet (224.0.0.1) standaard. Alleen uitwerking IGMP Multicasts change
# '-p ALL' naar '-p 2'. Natuurlijk, als ze niet elders worden geaccepteerd, zal
# het alleen voor zorgen dat multicasts op andere protocollen worden vastgelegd.
# Drop ze zonder houtkap.
$IPT -A INPUT -p ALL -d 224.0.0.1 -j DROP
# De regel om de pakketten te accepteren.
# $IPT -A INPUT -p ALL -d 224.0.0.1 -j ACCEPT

<?php
	if( $GATEWAY ) {
		// Rules for the private network
		print "
# Laat DHCP client verzoek ingaande pakketten vanuit het interne netwerk
\$IPT -A INPUT -p ALL -i \$LOCAL_IFACE -s \$LOCAL_NET -j ACCEPT
\$IPT -A INPUT -p ALL -i \$LOCAL_IFACE -d \$LOCAL_BCAST -j ACCEPT
";

		// If running DHCP internally from this server, also allow dhcp client requests
		print ( $INTERNAL_DHCP )
			? "
# Laat DHCP client verzoek ingaande pakketten vanuit het interne netwerk
\$IPT -A INPUT -p UDP -i \$LOCAL_IFACE --source-port 68 --destination-port 67 \\
     -j ACCEPT
"
			: '';
	}
?>

# Inbound Internet Packet Regels

# Accepteer Actieve verbindingen
$IPT -A INPUT -p ALL -i $INET_IFACE -m state --state ESTABLISHED,RELATED \
     -j ACCEPT

# Leg de rest aan de juiste gebruiker keten
$IPT -A INPUT -p TCP -i $INET_IFACE -j tcp_inbound
$IPT -A INPUT -p UDP -i $INET_IFACE -j udp_inbound
$IPT -A INPUT -p ICMP -i $INET_IFACE -j icmp_packets

# Drop zonder in te loggen uitzendingen die zo ver te komen.
# Bezuinigingen op log rommel. Geef commentaar op deze regel als het testen van
# nieuwe regels die van invloed zijn uitzending protocollen.
$IPT -A INPUT -m pkttype --pkt-type broadcast -j DROP

# Log pakketten die nog steeds niet overeenkomen
<?php
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $LOG_FIREPARSE )
		? "
\$IPT -A INPUT -j LOG --log-prefix \"fp=INPUT:99 a=DROP \"
"
		: "
\$IPT -A INPUT -m limit --limit 3/minute --limit-burst 3 -j LOG \\
    --log-prefix \"INPUT packet died: \"
";
?>

###############################################################################
#
# FORWARD Keten
#

echo "Proces FORWARD keten ... "

# Gebruikt als forwarding voor een prive-netwerk

<?php
	if( $GATEWAY ) {
		// private network exists
		print "
# Drop slecht pakketten
\$IPT -A FORWARD -p ALL -j bad_packets

# Accepteer TCP-pakketten die we willen doorsturen van interne bronnen
\$IPT -A FORWARD -p tcp -i \$LOCAL_IFACE -j tcp_outbound

# Accepteer UDP-pakketten die we willen doorsturen van interne bronnen
\$IPT -A FORWARD -p udp -i \$LOCAL_IFACE -j udp_outbound

# Indien niet geblokkeerd, aanvaarden geen enkele andere pakketten van
# de interne interface
\$IPT -A FORWARD -p ALL -i \$LOCAL_IFACE -j ACCEPT

# Omgaan met reacties van internet
\$IPT -A FORWARD -i \$INET_IFACE -m state --state ESTABLISHED,RELATED \\
     -j ACCEPT

";

		// If port forwarding option selected, the forward chain must also
		// accept the port forwarding.
		// one/both of PORT_FORWARD_TCP and/or PORT_FORWARD_UDP *must* be selected
		print ( $PORT_FORWARD and $PORT_FORWARD_UDP )
			? "
# Port Forwarding is ingeschakeld, waardoor accepteren doorgestuurd verkeer
\$IPT -A FORWARD -p udp -i \$INET_IFACE --destination-port ".		(
				(( empty( $PORT_FORWARD_IPORT ))
					? ( $PORT_FORWARD_FROM . (( empty( $PORT_FORWARD_TO )) ? '' : ":$PORT_FORWARD_TO"))
					: $PORT_FORWARD_IPORT
				) ." \\\n     --destination $PORT_FORWARD_IP -j ACCEPT\n\n"
			)
			: '';

		print ( $PORT_FORWARD and $PORT_FORWARD_TCP )
			? "
\$IPT -A FORWARD -p tcp -i \$INET_IFACE --destination-port ".
			(
				(( empty( $PORT_FORWARD_IPORT ))
					? ( $PORT_FORWARD_FROM . (( empty( $PORT_FORWARD_TO )) ? '' : ":$PORT_FORWARD_TO"))
					: $PORT_FORWARD_IPORT
				) ." \\\n     --destination $PORT_FORWARD_IP -j ACCEPT\n\n"
			)
			: '';

		print "# Log pakketten die nog steeds niet overeenkomen";

		// Check LOG_FIREPARSE to determine log-prefix format
		print ( $LOG_FIREPARSE )
			? "
\$IPT -A FORWARD -j LOG --log-prefix \"fp=FORWARD:99 a=DROP \"
"
			: "
\$IPT -A FORWARD -m limit --limit 3/minute --limit-burst 3 -j LOG \\
    --log-prefix \"FORWARD packet died: \"
";
	}
?>

###############################################################################
#
# OUTPUT Keten
#

echo "Proces OUTPUT chain ... "

# In het algemeen vertrouwen hebben in de firewall op uitgang

# Moeten echter ongeldig ICMP pakketten te laten vallen om te voorkomen dat
# een mogelijk benutten.
$IPT -A OUTPUT -m state -p icmp --state INVALID -j DROP

# Localhost
$IPT -A OUTPUT -p ALL -s $LO_IP -j ACCEPT
$IPT -A OUTPUT -p ALL -o $LO_IFACE -j ACCEPT

<?php
	// If private network exists
	print ( $GATEWAY )
		? "
# Om interne netwerk
\$IPT -A OUTPUT -p ALL -s \$LOCAL_IP -j ACCEPT
\$IPT -A OUTPUT -p ALL -o \$LOCAL_IFACE -j ACCEPT

"
		: '';
?>
# Om internet
$IPT -A OUTPUT -p ALL -o $INET_IFACE -j ACCEPT

# Log pakketten die nog steeds niet overeenkomen
<?php
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $LOG_FIREPARSE )
		? "\$IPT -A OUTPUT -j LOG --log-prefix \"fp=OUTPUT:99 a=DROP \""
		: "\$IPT -A OUTPUT -m limit --limit 3/minute --limit-burst 3 -j LOG \\
    --log-prefix \"OUTPUT packet died: \"";
?>


###############################################################################
#
# nat tafel
#
###############################################################################

# De nat tabel is waar network address translation treedt op als er een
# prive-netwerk. Als de gateway is verbonden met het internet met een
# statisch IP, wordt SNAT gebruikt. Indien de gateway een dynamisch adres moet
# gemaskerd worden gebruikt. Er is meer overhead geassocieerd met maskerade,
# dus snat is beter wanneer het gebruikt kan worden. De nat tabel heeft een
# ingebouwde keten, PREROUTING, voor DNAT en omleidingen. Een andere,
# POSTROUTING, handgrepen snat en maskerade.

echo "regels Load voor nat tabel ..."

###############################################################################
#
# PREROUTING Keten
#
<?php
	if( $PORT_FORWARD ) {
		// port forwarding option selected, build the rule here
		print "
# Port Forwarding

# Port forwarding stuurt alle verkeer op een poort of poorten van de firewall
# naar een computer op het interne netwerk. Dit kan worden verplicht om
# bijzondere situaties te ondersteunen. Zo, dit is de enige manier om de
# overdracht van bestanden met een ICQ-client ondersteunt op een interne
# computer. Het is ook nodig als een intern systeem herbergt een service, zoals
# een webserver. Echter, het is ook een gevaarlijke optie. Het laat Internet
# computers toegang tot uw interne netwerk. Zorgvuldig gebruiken en alleen als
# je zeker weet dat je weet wat je doet.
";

		print ( $PORT_FORWARD_UDP )
			? "
\$IPT -t nat -A PREROUTING -p udp -i \$INET_IFACE --destination-port $PORT_FORWARD_FROM".
(( empty( $PORT_FORWARD_TO )) ? '' : ":$PORT_FORWARD_TO") ." \\
     -j DNAT --to-destination $PORT_FORWARD_IP".
(( empty( $PORT_FORWARD_IPORT )) ? '' : ":$PORT_FORWARD_IPORT")."
"
			: '';

		print ( $PORT_FORWARD_TCP )
			? "
\$IPT -t nat -A PREROUTING -p tcp -i \$INET_IFACE --destination-port $PORT_FORWARD_FROM".
(( empty( $PORT_FORWARD_TO )) ? '' : ":$PORT_FORWARD_TO") ." \\
     -j DNAT --to-destination $PORT_FORWARD_IP".
(( empty( $PORT_FORWARD_IPORT )) ? '' : ":$PORT_FORWARD_IPORT")."
"
			: '';

		print ( $PORT_FORWARD_REDIR and $PORT_FORWARD_UDP )
			? "
\$IPT -t nat -A PREROUTING -p udp -i \$LOCAL_IFACE --destination-port $PORT_FORWARD_FROM".
(( empty( $PORT_FORWARD_TO )) ? '' : ":$PORT_FORWARD_TO") ." \\
     --destination \$INET_ADDRESS -j DNAT --to-destination $PORT_FORWARD_IP".
(( empty( $PORT_FORWARD_IPORT )) ? '' : ":$PORT_FORWARD_IPORT")."
"
			: '';

		print ( $PORT_FORWARD_REDIR and $PORT_FORWARD_TCP )
			? "
\$IPT -t nat -A PREROUTING -p tcp -i \$LOCAL_IFACE --destination-port $PORT_FORWARD_FROM".
(( empty( $PORT_FORWARD_TO )) ? '' : ":$PORT_FORWARD_TO") ." \\
     --destination \$INET_ADDRESS -j DNAT --to-destination $PORT_FORWARD_IP".
(( empty( $PORT_FORWARD_IPORT )) ? '' : ":$PORT_FORWARD_IPORT")."
"
			: '';

		// If TRANSPARENT_PROXY option set, redirect port 80 and port 443 to the
		// REDIRECT_PORT on the gateway machine
		print ( $TRANSPARENT_PROXY )
			? "
# Dit is een voorbeeld dat een specifieke gastheer zal vrijstellen van de
# transparante proxy
#\$IPT -t nat -A PREROUTING -p tcp -s 192.168.1.50 --destination-port 80 \\
#     -j RETURN
#\$IPT -t nat -A PREROUTING -p tcp -s 192.168.1.50 --destination-port 443 \\
#     -j RETURN

# Redirect HTTP voor een transparante proxy
\$IPT -t nat -A PREROUTING -p tcp --destination-port 80 \\
     -j REDIRECT --to-ports $REDIRECT_PORT

# Redirect HTTPS voor een transparante proxy - commentaar standaard
# \$IPT -t nat -A PREROUTING -p tcp --destination-port 443 \\
#     -j REDIRECT --to-ports $REDIRECT_PORT
"
			: '';
	}
?>

###############################################################################
#
# POSTROUTING Keten
#

<?php
	//If it's a gateway then install either snat or masquerade.
	print ( $GATEWAY )
		? (( $DYNAMIC_IP )	// masquerade or snat
			? "\$IPT -t nat -A POSTROUTING -o \$INET_IFACE -j MASQUERADE\n"
			: "\$IPT -t nat -A POSTROUTING -o \$INET_IFACE \\
     -j SNAT --to-source \$INET_ADDRESS\n".
			(( $PORT_FORWARD_REDIR )
				? "\$IPT -t nat -A POSTROUTING -o \$LOCAL_IFACE \\
     -j SNAT --to-source \$INET_ADDRESS
"
				: ''
			)
		)
		: '';
?>

###############################################################################
#
# mangle tafel
#
###############################################################################

# De mangle tabel wordt gebruikt om pakketten te veranderen. Het kan veranderen
# of mangel ze op verschillende manieren. Voor de toepassing van deze
# generator, we zijn vermogen om de TTL veranderen in pakketten alleen. Toch
# kan het worden gebruikt om netfilter merk waarden op specifieke pakketten.
# Deze merken zou dan kunnen worden gebruikt in een andere tabel, zoals filter,
# om activiteiten in verband met een specifieke host, bijvoorbeeld beperken. De
# TOS doel kan worden gebruikt om de Type of Service veld in de IP-header. Merk
# op dat de TTL doelstelling niet kunnen worden opgenomen in de distributie op
# uw systeem. Als het niet en je het nodig hebt, moet u deze toe te voegen.
# Dat kan verlangen dat u bouwen vanaf broncode.

echo "regels Load voor mangel tafel ..."
<?php
	// Reset the TTL if requested to do so.
	print ( $MANGLE_TTL )
		? "
# Stel de TTL van uitgaande pakketten dezelfde constante waarde. Een waarde
# rond 128 is een goede waarde. Niet ingesteld deze te hoog omdat het een
# negatieve invloed op uw netwerk. Het wordt ook beschouwd als slechte vorm op
# het internet.
\$IPT -t mangle -A OUTPUT -o \$INET_IFACE -j TTL --ttl-set $TTL
"
		: '';
// vi: shiftwidth=3 tabstop=3 et
?>
