<?php
/* efg.php
 *    Easy Firewall Generator
 *
 * 2014-03-25 v2.0.1 Added DA, DE, NL + INET_ADDRESS_KEY/_TITLE
 * 2014-03-16 v2.0.0 Released (EN, ES, FR)
 * 2014-02-18 v2.0.0 Started -AK
 *
 * TAB=3
 *
 * @category Net
 * @version $Id: efg.php, v2.0.1 2014-03-25
 * @author Alex KEMP http://www.modem-help.co.uk/
 */
 	error_reporting( E_ALL );
	ini_set('error_log', 'syslog');										// send errors to the system log
	ob_start();
	// see rblconfig.php for all define()s
	require_once('path/to/rblconfig.php');								// make sure is in include path, or specify fully
//	require_once( BOT_BLOCK_SCRIPT );									// damn useful, but not essential
	require_once( RBL_CONTEG_FILE );										// required - min v0.13.11
	require_once( BOT_TEMPLATE );											// required

// -------------- Start of Security Section ---------------
	if( $_REQUEST ) {
		while( list( $k, $v ) = each( $_REQUEST )) {
			if( is_array( $_REQUEST[ $k ])) {
				foreach( $_REQUEST[ $k ] as $aK => $aV ) {
					$_REQUEST[ $k ][ $aK ] = strTransform( trim( $aV ));
				}
			} else $_REQUEST[ $k ] = strTransform( trim( $v ));
		}
	}

	// these are all non-language-dependent variables
	$LANG						= ( isset( $_POST['lang']))					? strtoupper( substr( $_POST['lang'], 0, 2 ))			: '';
	$INET_IFACE				= ( isset( $_POST['INET_IFACE']))			? (string) substr( $_POST['INET_IFACE'], 0, 6 )			: 'eth0';
	$DYNAMIC_IP				= (( isset( $_POST['DYNAMIC_IP'])) and ( $_POST['DYNAMIC_IP'] == 'false'))
		? FALSE
		: TRUE;
	$INET_ADDRESS			= ( isset( $_POST['INET_ADDRESS']))			? (string) substr( $_POST['INET_ADDRESS'], 0, 15 )		: '';
	$GATEWAY					= (( isset( $_POST['GATEWAY'])) and ( $_POST['GATEWAY'] == 'true'))
		? TRUE
		: FALSE;
	$LOCAL_IFACE			= ( isset( $_POST['LOCAL_IFACE']))			? (string) substr( $_POST['LOCAL_IFACE'], 0, 6 )		: 'eth1';
	$LOCAL_IP				= ( isset( $_POST['LOCAL_IP']))				? (string) substr( $_POST['LOCAL_IP'], 0, 15 )			: '192.168.1.1';
	$LOCAL_NET				= ( isset( $_POST['LOCAL_NET']))				? (string) substr( $_POST['LOCAL_NET'], 0, 20 )			: '192.168.1.0/24';
	$LOCAL_BCAST			= ( isset( $_POST['LOCAL_BCAST']))			? (string) substr( $_POST['LOCAL_BCAST'], 0, 15 )		: '192.168.1.255';
	$SPECIAL_LAN			= (( isset( $_POST['SPECIAL_LAN'])) and ( $_POST['SPECIAL_LAN'] == 'true'))
		? TRUE
		: FALSE;
	$INTERNAL_DHCP			= (( isset( $_POST['INTERNAL_DHCP'])) and ( $_POST['INTERNAL_DHCP'] == 'true'))
		? TRUE
		: FALSE;
	$MANGLE_TTL				= (( isset( $_POST['MANGLE_TTL'])) and ( $_POST['MANGLE_TTL'] == 'true'))
		? TRUE
		: FALSE;
	$TTL						= ( isset( $_POST['TTL']))						? (int) substr( $_POST['TTL'], 0, 4 )						: '128';
	$TRANSPARENT_PROXY	= (( isset( $_POST['TRANSPARENT_PROXY'])) and ( $_POST['TRANSPARENT_PROXY'] == 'true'))
		? TRUE
		: FALSE;
	$REDIRECT_PORT			= ( isset( $_POST['REDIRECT_PORT']))		? (int) substr( $_POST['REDIRECT_PORT'], 0, 6 )			: '';
	$PORT_FORWARD			= (( isset( $_POST['PORT_FORWARD'])) and ( $_POST['PORT_FORWARD'] == 'true'))
		? TRUE
		: FALSE;
	$PORT_FORWARD_FROM	= ( isset( $_POST['PORT_FORWARD_FROM']))	? (int) substr( $_POST['PORT_FORWARD_FROM'], 0, 6 )	: '';
	$PORT_FORWARD_TO		= ( isset( $_POST['PORT_FORWARD_TO']))		? (int) substr( $_POST['PORT_FORWARD_TO'], 0, 6 )		: '';
	$PORT_FORWARD_TCP		= (( isset( $_POST['PORT_FORWARD_TCP'])) and ( $_POST['PORT_FORWARD_TCP'] == 'true'))
		? TRUE
		: FALSE;
	$PORT_FORWARD_UDP		= (( isset( $_POST['PORT_FORWARD_UDP'])) and ( $_POST['PORT_FORWARD_UDP'] == 'true'))
		? TRUE
		: FALSE;
	if(( $PORT_FORWARD_TCP == FALSE ) and ( $PORT_FORWARD_UDP == FALSE ))		$PORT_FORWARD_TCP	= TRUE;
	$PORT_FORWARD_IP		= ( isset( $_POST['PORT_FORWARD_IP']))		? (string) substr( $_POST['PORT_FORWARD_IP'], 0, 15 )	: '';
	$PORT_FORWARD_IPORT	= ( isset( $_POST['PORT_FORWARD_IPORT']))	? (int) substr( $_POST['PORT_FORWARD_IPORT'], 0, 6 )	: '';
	$PORT_FORWARD_REDIR	= (( isset( $_POST['PORT_FORWARD_REDIR'])) and ( $_POST['PORT_FORWARD_REDIR'] == 'true'))
		? TRUE
		: FALSE;
	$BLOCK_OUTBOUND		= (( isset( $_POST['BLOCK_OUTBOUND'])) and ( $_POST['BLOCK_OUTBOUND'] == 'true'))
		? TRUE
		: FALSE;
	$IRC_OUT					= (( isset( $_POST['IRC_OUT'])) and ( $_POST['IRC_OUT'] == 'true'))
		? TRUE
		: FALSE;
	$TELNET_OUT				= (( isset( $_POST['TELNET_OUT'])) and ( $_POST['TELNET_OUT'] == 'true'))
		? TRUE
		: FALSE;
	$HTTP_OUT				= (( isset( $_POST['HTTP_OUT'])) and ( $_POST['HTTP_OUT'] == 'true'))
		? TRUE
		: FALSE;
	$FTP_OUT					= (( isset( $_POST['FTP_OUT'])) and ( $_POST['FTP_OUT'] == 'true'))
		? TRUE
		: FALSE;
	$IM_OUT					= (( isset( $_POST['IM_OUT'])) and ( $_POST['IM_OUT'] == 'true'))
		? TRUE
		: FALSE;
	$NEWS_OUT				= (( isset( $_POST['NEWS_OUT'])) and ( $_POST['NEWS_OUT'] == 'true'))
		? TRUE
		: FALSE;
	$EMAIL_OUT				= (( isset( $_POST['EMAIL_OUT'])) and ( $_POST['EMAIL_OUT'] == 'true'))
		? TRUE
		: FALSE;
	$SSH_OUT					= (( isset( $_POST['SSH_OUT'])) and ( $_POST['SSH_OUT'] == 'true'))
		? TRUE
		: FALSE;
	$INBOUND_ALLOW			= (( isset( $_POST['INBOUND_ALLOW'])) and ( $_POST['INBOUND_ALLOW'] == 'true'))
		? TRUE
		: FALSE;
	$SSH_IN					= (( isset( $_POST['SSH_IN'])) and ( $_POST['SSH_IN'] == 'true'))
		? TRUE
		: FALSE;
	$DNS_IN					= (( isset( $_POST['DNS_IN'])) and ( $_POST['DNS_IN'] == 'true'))
		? TRUE
		: FALSE;
	$HTTP_IN					= (( isset( $_POST['HTTP_IN'])) and ( $_POST['HTTP_IN'] == 'true'))
		? TRUE
		: FALSE;
	$HTTPSSL_IN				= (( isset( $_POST['HTTPSSL_IN'])) and ( $_POST['HTTPSSL_IN'] == 'true'))
		? TRUE
		: FALSE;
	$FTP_IN					= (( isset( $_POST['FTP_IN'])) and ( $_POST['FTP_IN'] == 'true'))
		? TRUE
		: FALSE;
	$PASSIVE_IN				= (( isset( $_POST['PASSIVE_IN'])) and ( $_POST['PASSIVE_IN'] == 'true'))
		? TRUE
		: FALSE;
	$PASSIVE_PORT_FROM	= ( isset( $_POST['PASSIVE_PORT_FROM']))	? (int) substr( $_POST['PASSIVE_PORT_FROM'], 0, 6 )	: '62000';
	$PASSIVE_PORT_TO		= ( isset( $_POST['PASSIVE_PORT_TO']))		? (int) substr( $_POST['PASSIVE_PORT_TO'], 0, 6 )		: '64000';
	$EMAIL_IN				= (( isset( $_POST['EMAIL_IN'])) and ( $_POST['EMAIL_IN'] == 'true'))
		? TRUE
		: FALSE;
	$EMAILSSL_IN			= (( isset( $_POST['EMAILSSL_IN'])) and ( $_POST['EMAILSSL_IN'] == 'true'))
		? TRUE
		: FALSE;
	$NTP_IN					= (( isset( $_POST['NTP_IN'])) and ( $_POST['NTP_IN'] == 'true'))
		? TRUE
		: FALSE;
	$DHCP_IN					= (( isset( $_POST['DHCP_IN'])) and ( $_POST['DHCP_IN'] == 'true'))
		? TRUE
		: FALSE;
	$IM_IN					= (( isset( $_POST['IM_IN'])) and ( $_POST['IM_IN'] == 'true'))
		? TRUE
		: FALSE;
	$IM_PORT_FROM			= ( isset( $_POST['IM_PORT_FROM']))			? (int) substr( $_POST['IM_PORT_FROM'], 0, 6 )			: '5000';
	$IM_PORT_TO				= ( isset( $_POST['IM_PORT_TO']))			? (int) substr( $_POST['IM_PORT_TO'], 0, 6 )				: '5100';
	$MESSENGER_IN			= (( isset( $_POST['MESSENGER_IN'])) and ( $_POST['MESSENGER_IN'] == 'true'))
		? TRUE
		: FALSE;
	$MSN_PORT_FROM			= ( isset( $_POST['MSN_PORT_FROM']))		? (int) substr( $_POST['MSN_PORT_FROM'], 0, 6 )			: '6891';
	$MSN_PORT_TO			= ( isset( $_POST['MSN_PORT_TO']))			? (int) substr( $_POST['MSN_PORT_TO'], 0, 6 )			: '6900';
	$NFS_IN					= (( isset( $_POST['NFS_IN'])) and ( $_POST['NFS_IN'] == 'true'))
		? TRUE
		: FALSE;
	$STATD_PORT				= ( isset( $_POST['STATD_PORT']))			? (int) substr( $_POST['STATD_PORT'], 0, 6 )				: '9400';
	$LOCKD_PORT				= ( isset( $_POST['LOCKD_PORT']))			? (int) substr( $_POST['LOCKD_PORT'], 0, 6 )				: '9401';
	$MOUNTD_PORT			= ( isset( $_POST['MOUNTD_PORT']))			? (int) substr( $_POST['MOUNTD_PORT'], 0, 6 )			: '9402';
	$RQUOTAD_PORT			= ( isset( $_POST['RQUOTAD_PORT']))			? (int) substr( $_POST['RQUOTAD_PORT'], 0, 6 )			: '9403';
	$MDNSRESPONDER_IN		= (( isset( $_POST['MDNSRESPONDER_IN'])) and ( $_POST['MDNSRESPONDER_IN'] == 'true'))
		? TRUE
		: FALSE;
	$OTHER_IN				= (( isset( $_POST['OTHER_IN'])) and ( $_POST['OTHER_IN'] == 'true'))
		? TRUE
		: FALSE;
	$OTHER_IN_FROM			= ( isset( $_POST['OTHER_IN_FROM']))		? (int) substr( $_POST['OTHER_IN_FROM'], 0, 6 )			: '';
	$OTHER_IN_TO			= ( isset( $_POST['OTHER_IN_TO']))			? (int) substr( $_POST['OTHER_IN_TO'], 0, 6 )			: '';
	$OTHER_IN_TCP			= (( isset( $_POST['OTHER_IN_TCP'])) and ( $_POST['OTHER_IN_TCP'] == 'true'))
		? TRUE
		: FALSE;
	$OTHER_IN_UDP			= (( isset( $_POST['OTHER_IN_UDP'])) and ( $_POST['OTHER_IN_UDP'] == 'true'))
		? TRUE
		: FALSE;
	if(( $OTHER_IN_TCP == FALSE ) and ( $OTHER_IN_UDP == FALSE ))	$OTHER_IN_TCP	= TRUE;
	$LOG_FIREPARSE	= (( isset( $_POST['LOG_FIREPARSE'])) and ( $_POST['LOG_FIREPARSE'] == 'true'))
		? TRUE
		: FALSE;
	$IRC_USER				= (( isset( $_POST['IRC_USER'])) and ( $_POST['IRC_USER'] == 'true'))
		? TRUE
		: FALSE;
	// we need to be able to distinguish between a button press submit & an auto-submit via lang dropdown
	$SUBMIT					= (( isset( $_POST['Submit'])) and ( $_POST['Submit'] == 'Submit'))
		? TRUE
		: FALSE;
// -------------- End   of Security Section ---------------
// -------------- Start of Language Section ---------------
	// init lang arrays + (default) English for template
	$S_CONTENT_DIRECTION			= array();

	$BLOCK_OUTBOUND_KEY			= array();
	$BLOCK_OUTBOUND_TITLE		= array();
	$BUTTON_TEXT					= array();
	$DHCP_IN_KEY					= array();
	$DHCP_IN_TITLE					= array();
	$DNS_IN_KEY						= array();
	$DNS_IN_TITLE					= array();
	$DYNAMIC_IP_NO_KEY			= array();
	$DYNAMIC_IP_NO_TITLE			= array();
	$DYNAMIC_IP_TITLE				= array();
	$DYNAMIC_IP_YES_KEY			= array();
	$DYNAMIC_IP_YES_TITLE		= array();
	$EMAIL_IN_KEY					= array();
	$EMAIL_IN_TITLE				= array();
	$EMAILSSL_IN_KEY				= array();
	$EMAILSSL_IN_TITLE			= array();
	$EMAIL_OUT_KEY					= array();
	$EMAIL_OUT_TITLE				= array();
	$FTP_IN_KEY						= array();
	$FTP_IN_TITLE					= array();
	$FTP_OUT_KEY					= array();
	$FTP_OUT_TITLE					= array();
	$GATEWAY_NO_KEY				= array();
	$GATEWAY_NO_TITLE				= array();
	$GATEWAY_TITLE					= array();
	$GATEWAY_YES_KEY				= array();
	$GATEWAY_YES_TITLE			= array();
	$HELP								= array();
	$HTTP_IN_KEY					= array();
	$HTTP_IN_TITLE					= array();
	$HTTPSSL_IN_KEY				= array();
	$HTTPSSL_IN_TITLE				= array();
	$HTTP_OUT_KEY					= array();
	$HTTP_OUT_TITLE				= array();
	$INET_IFACE_TITLE				= array();
	$IM_IN_KEY						= array();
	$IM_IN_TITLE					= array();
	$IM_OUT_KEY						= array();
	$IM_OUT_TITLE					= array();
	$IM_PORT_FROM_KEY				= array();
	$IM_PORT_FROM_TITLE			= array();
	$IM_PORT_TO_KEY				= array();
	$IM_PORT_TO_TITLE				= array();
	$INBOUND_ALLOW_KEY			= array();
	$INBOUND_ALLOW_TITLE			= array();
	$INET_ADDRESS_KEY				= array();
	$INET_ADDRESS_TITLE			= array();
	$INTERNAL_DHCP_KEY			= array();
	$INTERNAL_DHCP_TITLE			= array();
	$IRC_OUT_KEY					= array();
	$IRC_OUT_TITLE					= array();
	$IRC_USER_KEY					= array();
	$IRC_USER_TITLE				= array();
	$L_POST							= array();
	$L_SUBMIT						= array();
	$LOCAL_BCAST_KEY				= array();
	$LOCAL_BCAST_TITLE			= array();
	$LOCAL_IFACE_KEY				= array();
	$LOCAL_IFACE_TITLE			= array();
	$LOCAL_IP_KEY					= array();
	$LOCAL_IP_TITLE				= array();
	$LOCAL_NET_KEY					= array();
	$LOCAL_NET_TITLE				= array();
	$LOCKD_PORT_KEY				= array();
	$LOCKD_PORT_TITLE				= array();
	$LOG_FIREPARSE_KEY			= array();
	$LOG_FIREPARSE_TITLE			= array();
	$MANGLE_TTL_KEY				= array();
	$MANGLE_TTL_TITLE				= array();
	$MDNSRESPONDER_IN_KEY		= array();
	$MDNSRESPONDER_IN_TITLE		= array();
	$MESSENGER_IN_KEY				= array();
	$MESSENGER_IN_TITLE			= array();
	$MOUNTD_PORT_KEY				= array();
	$MOUNTD_PORT_TITLE			= array();
	$MSN_PORT_FROM_KEY			= array();
	$MSN_PORT_FROM_TITLE			= array();
	$MSN_PORT_TO_KEY				= array();
	$MSN_PORT_TO_TITLE			= array();
	$OTHER_IN_KEY					= array();
	$OTHER_IN_TITLE				= array();
	$OTHER_IN_FROM_KEY			= array();
	$OTHER_IN_FROM_TITLE			= array();
	$OTHER_IN_TCP_TITLE			= array();
	$OTHER_IN_TO_KEY				= array();
	$OTHER_IN_TO_TITLE			= array();
	$OTHER_IN_UDP_TITLE			= array();
	$NEWS_OUT_KEY					= array();
	$NEWS_OUT_TITLE				= array();
	$NFS_IN_KEY						= array();
	$NFS_IN_TITLE					= array();
	$NTP_IN_KEY						= array();
	$NTP_IN_TITLE					= array();
	$PAGE_TITLE						= array();
	$PASSIVE_IN_KEY				= array();
	$PASSIVE_IN_TITLE				= array();
	$PASSIVE_IN_KEY				= array();
	$PASSIVE_PORT_FROM_KEY		= array();
	$PASSIVE_PORT_FROM_TITLE	= array();
	$PASSIVE_PORT_TO_KEY			= array();
	$PASSIVE_PORT_TO_TITLE		= array();
	$PORT_FORWARD_KEY				= array();
	$PORT_FORWARD_TITLE			= array();
	$PORT_FORWARD_FROM_KEY		= array();
	$PORT_FORWARD_FROM_TITLE	= array();
	$PORT_FORWARD_IP_KEY			= array();
	$PORT_FORWARD_IP_TITLE		= array();
	$PORT_FORWARD_IPORT_KEY		= array();
	$PORT_FORWARD_IPORT_TITLE	= array();
	$PORT_FORWARD_REDIR_KEY		= array();
	$PORT_FORWARD_REDIR_TITLE	= array();
	$PORT_FORWARD_TO_KEY			= array();
	$PORT_FORWARD_TO_TITLE		= array();
	$SPECIAL_LAN_KEY				= array();
	$SPECIAL_LAN_TITLE			= array();
	$REDIRECT_PORT_KEY			= array();
	$REDIRECT_PORT_TITLE			= array();
	$RQUOTAD_PORT_KEY				= array();
	$RQUOTAD_PORT_TITLE			= array();
	$SSH_IN_KEY						= array();
	$SSH_IN_TITLE					= array();
	$SSH_OUT_KEY					= array();
	$SSH_OUT_TITLE					= array();
	$STATD_PORT_KEY				= array();
	$STATD_PORT_TITLE				= array();
	$SUBMIT_KEY						= array();
	$TELNET_OUT_KEY				= array();
	$TELNET_OUT_TITLE				= array();
	$TOOLTIP							= array();
	$TOPIC_TITLE					= array();
	$TTL_KEY							= array();
	$TTL_TITLE						= array();
	$TRANSPARENT_PROXY_KEY		= array();
	$TRANSPARENT_PROXY_TITLE	= array();
	$TRANSPARENT_PROXY_TITLE	= array();
	// these deliberately out-of-order
	$ENTRY_TIP						= array();
	$ENTRY_TIP_WHOOPS				= array();
	$G_POPUP_WARN					= '&#x279A;';
	$G_STYLE_DL_NO					= '#ff6600';
	$G_STYLE_DL_YES				= '#66ff66';
	$HELP_TXT						= array();
// -------------- End   of Language Section ---------------
// -------------- Start of Common-top Section -------------
	$_Encode							= new Conteg( array(
		'cpu_number'			=> RBL_CPU_NUM,	// number of CPU in server
		'noprint'				=> TRUE,				// display page only on explicit show()
		'use_etag'				=> TRUE,
		'use_accept_lang'		=> TRUE,				// vary by language
		'use_apache_notes'	=> TRUE,				// pass compression stats to Apache logs
	));
	$Display							= '';
	$downloadFW						= TRUE;
	$MODIFIED						= strtotime('2014-03-25');
	$NO_FW_STYLE					= "border:thin dotted $G_STYLE_DL_NO;";
	$no_fw_style					= " style='$NO_FW_STYLE'";
	$NO_POST							= ( isset( $_POST['INET_IFACE']))	? FALSE	: TRUE;
	$NOW								= date('Y-m-d');
	$Template						= new Template( RBL_PATH .'include');	// non language-dependent
	$template						= 'efg_form.tpl';
	$VERSION							= 'v2.0.1';
	$YEAR_NOW						= date('Y');

	$_LANG							= 'EN';	// default
	// next section so no need to import 100+ include files!
	// my wretched Windows-based editor keeps switching back to ANSI
	// the foll therefore a Horrible Hack (TM) (also cannot use html entities)
	// for code-points: http://www.utf8-chartable.de/
	$c									= "\xC3\xA7";
	$n									= "\xC3\xB1";
	$OPTIONS							= array(
											'DA' => 'DA Dansk',
											'DE' => 'DE Deutsch',
											'EN' => 'EN English',
											'ES' => "ES Espa{$n}ol",
											'FR' => "FR Fran{$c}ais",
											'NL' => "NL Nederlandse",
										);

	// lang processing
	if( !empty( $LANG )) {
		// is POST + specific language requested
		$tmp		= BOT_LANG_DIR ."/$LANG/efg.inc";
		if(( isset( $OPTIONS[ $LANG ])) and ( file_exists( $tmp ))) {
			$_LANG	= $LANG;
		}
	} else {
		if( $NO_POST ) {
			// try to find user default language
			$tmp		= $_Encode->getAcceptLang();
			$con		= TRUE;
			// find most acceptable lang; array is in order of preference, high to low
			foreach( $tmp as $lang => $i ) {
				// perversely, lang is the key & order is the value
				// (done that way so arsort will work)
				if( $con ) {
					if( $lang == '*') {	// any lang is acceptable
						// use lang default ($_LANG)
						$con		= FALSE;
					} else {
						$lang	= strtoupper( substr( $lang, 0, 2 ));
						if(( isset( $OPTIONS[ $lang ])) and ( file_exists( BOT_LANG_DIR ."/$lang/efg.inc"))) {
							$_LANG	= $lang;
							$con		= FALSE;
						}
					}
				}
			}
		} // if( $NO_POST )
	}	// if( !empty( $LANG )) else

	$LANG_OPTIONS					= '';
	foreach( $OPTIONS as $key => $val ) {
		$LANG_OPTIONS	.= "<option value='$key'".
			(($_LANG == $key ) ? " selected='selected'" : '').
			">$val</option>\n";
	}

	$tmp								= BOT_LANG_DIR ."/$_LANG/efg.inc";
	require_once( $tmp );

	// paranoid programming
	$RESULTS							= '';
	if(( $RESULTS = $_Encode->isError()) and ( strpos( $RESULTS, 'STOP ERROR') !== FALSE )) {
		// a stop-program error occurred during Conteg instantiation
		// consult SysLog to see the full error
		// this is designed for a production system, so warnings & notices are ignored (but sent to SysLog)

		// we cannot now trust Conteg to be able to issue a `friendly' error page
		if( !headers_sent()) {
			header('HTTP/1.0 500: Internal Server Error');
		}
		trigger_error( $RESULTS, E_USER_ERROR );
		exit;	// redundant programming
	} elseif( empty( $S_CONTENT_DIRECTION[ $_LANG ])) {
		// reset to default language
		$RESULTS								= "Content reset; \$S_CONTENT_DIRECTION['$_LANG'] is empty.";
		trigger_error( $RESULTS, E_USER_NOTICE );

		$_LANG								= 'EN';
		$conteg_param['http_status']	= '205';	// reset content
		$tmp									= BOT_LANG_DIR ."/$_LANG/efg.inc";	// default *should* always be available
		require_once( $tmp );

		// truly paranoid programming
		if( empty( $S_CONTENT_DIRECTION[ $_LANG ])) {
			$RESULTS	= "An unknown Server error occurred whilst getting the page.<br /><br />Our apologies. Please try again later.";

			if( !( $Display = @include( BOT_LANG_DIR ."/$_LANG/show_500_efg.php"))) {
				if( !headers_sent()) {
					header('HTTP/1.0 500: Internal Server Error');
				}
				trigger_error( $RESULTS, E_USER_ERROR );
				exit;
			}
			$conteg_param	= array(
				'cache_control'	=> array('macro' => 'cache-none'),
				'http_status'		=> '500'
			);
			echo $Display;	// error msg
			$_Encode->setup( $conteg_param );
			$_Encode->show();
			exit;
		}
	}	// if( ...'STOP ERROR' in Conteg ... ) elseif( empty( $S_CONTENT_DIRECTION[ $LANG ]))

	// IP/CIDR check for preg
	$tmp								= '[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}';
	$IPcheck							= "#$tmp#";
	$CIDRcheck						= "#$tmp/[0-9]{1,2}#";

	// one template for all pages
	$Template->set_filenames( array('body' => $template ));

	// non language-dependent values for template
	$HOME								= U_INDEX .'efg.php';
	$L_VIEW_NAV						= " &raquo; <a href='$HOME' class='nav'>{$PAGE_TITLE[$_LANG]}</a>";
	$META								= '';
	$NAV_LINKS						= '';
	$PORT_FORWARD_TCP_TITLE		= 'TCP';
	$PORT_FORWARD_UDP_TITLE		= 'UDP';
	$S_CONTENT_ENCODING			= 'utf-8';
	$S_HIDDEN_FORMFIELDS			= '';
	$S_POST_ACTION					= $HOME;
	$U_BLOCK_OUTBOUND				= U_INDEX ."language/$_LANG/help-blockout.html";
	$U_DNS_IN						= U_INDEX ."language/$_LANG/help-dnsserver.html";
	$U_DYNAMIC_IP					= U_INDEX ."language/$_LANG/help-dynamic.html";
	$U_GATEWAY						= U_INDEX ."language/$_LANG/help-gateway.html";
	$U_IM_PORT_TO					= U_INDEX ."language/$_LANG/help-imports.html";
	$U_INBOUND_ALLOW				= U_INDEX ."language/$_LANG/help-allowin.html";
	$U_INET_ADDRESS				= U_INDEX ."language/$_LANG/help-ipaddress.html";
	$U_INET_IFACE					= U_INDEX ."language/$_LANG/help-interface.html";
	$U_INTERNAL_DHCP				= U_INDEX ."language/$_LANG/help-internaldhcp.html";
	$U_IRC_USER						= U_INDEX ."language/$_LANG/help-ircuser.html";
	$U_LOCAL_BCAST					= U_INDEX ."language/$_LANG/help-broadcast.html";
	$U_LOCAL_IFACE					= $U_INET_IFACE;
	$U_LOCAL_IP						= $U_INET_ADDRESS;
	$U_LOCAL_NET					= U_INDEX ."language/$_LANG/help-network.html";
	$U_LOG_FIREPARSE				= U_INDEX ."language/$_LANG/help-fireparse.html";
	$U_MSN_PORT_TO					= U_INDEX ."language/$_LANG/help-messengerports.html";
	$U_MDNSRESPONDER_IN			= U_INDEX ."language/$_LANG/help-mdnsresponder.html";
	$U_OTHER_IN						= U_INDEX ."language/$_LANG/help-otherin.html";
	$U_PASSIVE_PORT_TO			= U_INDEX ."language/$_LANG/help-passiveftp.html";
	$U_PORT_FORWARD				= U_INDEX ."language/$_LANG/help-portforward.html";
	$U_PORT_FORWARD_REDIR		= U_INDEX ."language/$_LANG/help-pfinternalredirect.html";
	$U_REDIRECT_PORT				= U_INDEX ."language/$_LANG/help-redirect.html";
	$U_RQUOTAD_PORT				= U_INDEX ."language/$_LANG/help-inboundnfs.html";
	$U_SPECIAL_LAN					= U_INDEX ."language/$_LANG/help-advanced.html";
	$U_TTL							= U_INDEX ."language/$_LANG/help-manglettl.html";
	$U_VIEW_TOPIC					= '';

	// lunatic-large variable default declarations to prevent php Notices
	// and reduce program lines below
	$BLOCK_OUTBOUND_DISABLED		= // deliberately left empty
	$BLOCK_OUTBOUND_STYLE			= // deliberately left empty
	$DHCP_IN_DISABLED					= // deliberately left empty
	$DHCP_IN_STYLE						= // deliberately left empty
	$DNS_IN_DISABLED					= // deliberately left empty
	$DNS_IN_STYLE						= // deliberately left empty
	$EMAIL_IN_DISABLED				= // deliberately left empty
	$EMAIL_IN_STYLE					= // deliberately left empty
	$EMAIL_OUT_DISABLED				= // deliberately left empty
	$EMAIL_OUT_STYLE					= // deliberately left empty
	$EMAILSSL_IN_DISABLED			= // deliberately left empty
	$FTP_IN_DISABLED					= // deliberately left empty
	$FTP_IN_STYLE						= // deliberately left empty
	$FTP_OUT_DISABLED					= // deliberately left empty
	$FTP_OUT_STYLE						= // deliberately left empty
	$HTTP_IN_DISABLED					= // deliberately left empty
	$HTTP_IN_STYLE						= // deliberately left empty
	$HTTP_OUT_DISABLED				= // deliberately left empty
	$HTTP_OUT_STYLE					= // deliberately left empty
	$HTTPSSL_IN_DISABLED				= // deliberately left empty
	$IM_IN_DISABLED					= // deliberately left empty
	$IM_IN_STYLE						= // deliberately left empty
	$IM_OUT_DISABLED					= // deliberately left empty
	$IM_OUT_STYLE						= // deliberately left empty
	$IM_PORT_FROM_DISABLED			= // deliberately left empty
	$IM_PORT_FROM_STYLE				= // deliberately left empty
	$IM_PORT_TO_DISABLED				= // deliberately left empty
	$INET_ADDRESS_DISABLED			= // deliberately left empty
	$INET_ADDRESS_STYLE				= // deliberately left empty
	$INTERNAL_DHCP_DISABLED			= // deliberately left empty
	$INTERNAL_DHCP_STYLE				= // deliberately left empty
	$IRC_OUT_DISABLED					= // deliberately left empty
	$IRC_OUT_STYLE						= // deliberately left empty
	$LOCAL_BCAST_DISABLED			= // deliberately left empty
	$LOCAL_BCAST_STYLE				= // deliberately left empty
	$LOCAL_IFACE_DISABLED			= // deliberately left empty
	$LOCAL_IFACE_STYLE				= // deliberately left empty
	$LOCAL_IP_DISABLED				= // deliberately left empty
	$LOCAL_IP_STYLE					= // deliberately left empty
	$LOCAL_NET_DISABLED				= // deliberately left empty
	$LOCAL_NET_STYLE					= // deliberately left empty
	$LOCKD_PORT_DISABLED				= // deliberately left empty
	$MANGLE_TTL_DISABLED				= // deliberately left empty
	$MANGLE_TTL_STYLE					= // deliberately left empty
	$MDNSRESPONDER_IN_DISABLED		= // deliberately left empty
	$MDNSRESPONDER_IN_STYLE			= // deliberately left empty
	$MESSENGER_IN_DISABLED			= // deliberately left empty
	$MESSENGER_IN_STYLE				= // deliberately left empty
	$MOUNTD_PORT_DISABLED			= // deliberately left empty
	$MSN_PORT_FROM_DISABLED			= // deliberately left empty
	$MSN_PORT_FROM_STYLE				= // deliberately left empty
	$MSN_PORT_TO_DISABLED			= // deliberately left empty
	$NEWS_OUT_DISABLED				= // deliberately left empty
	$NEWS_OUT_STYLE					= // deliberately left empty
	$NFS_IN_DISABLED					= // deliberately left empty
	$NFS_IN_STYLE						= // deliberately left empty
	$NTP_IN_DISABLED					= // deliberately left empty
	$NTP_IN_STYLE						= // deliberately left empty
	$OTHER_IN_DISABLED				= // deliberately left empty
	$OTHER_IN_FROM_DISABLED			= // deliberately left empty
	$OTHER_IN_FROM_STYLE				= // deliberately left empty
	$OTHER_IN_STYLE					= // deliberately left empty
	$OTHER_IN_TCP_DISABLED			= // deliberately left empty
	$OTHER_IN_TO_DISABLED			= // deliberately left empty
	$OTHER_IN_UDP_DISABLED			= // deliberately left empty
	$PASSIVE_IN_DISABLED				= // deliberately left empty
	$PASSIVE_PORT_FROM_DISABLED	= // deliberately left empty
	$PASSIVE_PORT_FROM_STYLE		= // deliberately left empty
	$PASSIVE_PORT_TO_DISABLED		= // deliberately left empty
	$PORT_FORWARD_DISABLED			= // deliberately left empty
	$PORT_FORWARD_FROM_DISABLED	= // deliberately left empty
	$PORT_FORWARD_FROM_STYLE		= // deliberately left empty
	$PORT_FORWARD_IP_DISABLED		= // deliberately left empty
	$PORT_FORWARD_IP_STYLE			= // deliberately left empty
	$PORT_FORWARD_IPORT_DISABLED	= // deliberately left empty
	$PORT_FORWARD_REDIR_DISABLED	= // deliberately left empty
	$PORT_FORWARD_STYLE				= // deliberately left empty
	$PORT_FORWARD_TCP_DISABLED		= // deliberately left empty
	$PORT_FORWARD_TO_DISABLED		= // deliberately left empty
	$PORT_FORWARD_UDP_DISABLED		= // deliberately left empty
	$REDIRECT_PORT_DISABLED			= // deliberately left empty
	$REDIRECT_PORT_STYLE				= // deliberately left empty
	$RQUOTAD_PORT_DISABLED			= // deliberately left empty
	$SSH_IN_DISABLED					= // deliberately left empty
	$SSH_IN_STYLE						= // deliberately left empty
	$SSH_OUT_DISABLED					= // deliberately left empty
	$SSH_OUT_STYLE						= // deliberately left empty
	$STATD_PORT_DISABLED				= // deliberately left empty
	$STATD_PORT_STYLE					= // deliberately left empty
	$TELNET_OUT_DISABLED				= // deliberately left empty
	$TELNET_OUT_STYLE					= // deliberately left empty
	$TRANSPARENT_PROXY_DISABLED	= // deliberately left empty
	$TRANSPARENT_PROXY_STYLE		= // deliberately left empty
	$TTL_DISABLED						= // deliberately left empty
	$TTL_STYLE							= '';
// -------------- End   of Common-top Section -------------
// -------------- Start of Display Section ----------------
	// Start of No-Content-Needed Check
	if( $NO_POST ) {
		// browsers do not send If-Modified, etc. on POST
		// important that $conteg_param exactly matches setup at end of script
		$conteg_param		= array(
			'charset'				=> $S_CONTENT_ENCODING,
			'lang'					=> $_LANG,
			'modified'				=> $MODIFIED,
		);
		$_Encode->setup( $conteg_param );
		if( $_Encode->isResponseNoContent()) {
			// 304, 406 or 412
			$_Encode->show();
			exit();
		}
	// End of No-Content-Needed Check

		$downloadFW					= FALSE;
	}	// if( $NO_POST )

// BEGIN complete program-flow template variables (checkbox + dependencies)
	// static or dynamic IP
	if( $DYNAMIC_IP ) {
		$DYNAMIC_IP_YES_CHK		= ' checked';
		$DYNAMIC_IP_NO_CHK		= '';
		$INET_ADDRESS_DISABLED	= ' disabled';
	} else {
		$DYNAMIC_IP_YES_CHK		= '';
		$DYNAMIC_IP_NO_CHK		= ' checked';

		if(( empty( $INET_ADDRESS )) or ( preg_match( $IPcheck, $INET_ADDRESS ) === 0 )) {
			$INET_ADDRESS				= '';
			$INET_ADDRESS_STYLE		= $no_fw_style;
			$downloadFW					= FALSE;
		}
	}
	// single device or gateway
	if( $GATEWAY ) {
		$GATEWAY_YES_CHK			= ' checked';
		$GATEWAY_NO_CHK			= '';

		if(( empty( $LOCAL_BCAST )) or ( preg_match( $IPcheck, $LOCAL_BCAST ) === 0 )) {
			$LOCAL_BCAST				= '';
			$LOCAL_BCAST_STYLE		= $no_fw_style;
			$downloadFW					= FALSE;
		}
		if( empty( $LOCAL_IFACE )) {
			$LOCAL_IFACE				= '';
			$LOCAL_IFACE_STYLE		= $no_fw_style;
			$downloadFW					= FALSE;
		}
		if(( empty( $LOCAL_IP )) or ( preg_match( $IPcheck, $LOCAL_IP ) === 0 )) {
			$LOCAL_IP					= '';
			$LOCAL_IP_STYLE			= $no_fw_style;
			$downloadFW					= FALSE;
		}
		if(( empty( $LOCAL_NET )) or ( preg_match( $CIDRcheck, $LOCAL_NET ) === 0 )) {
			$LOCAL_NET					= '';
			$LOCAL_NET_STYLE			= $no_fw_style;
			$downloadFW					= FALSE;
		}
	} else {
		$GATEWAY_YES_CHK					= '';
		$GATEWAY_NO_CHK					= ' checked';
		$LOCAL_BCAST_DISABLED			= // deliberately left empty
		$LOCAL_IFACE_DISABLED			= // deliberately left empty
		$LOCAL_IP_DISABLED				= // deliberately left empty
		$LOCAL_NET_DISABLED				= ' disabled';
	}
	// advanced network options
	if( $SPECIAL_LAN ) {
		$SPECIAL_LAN_CHK					= ' checked';

		// at least one child checkbox must be selected
		if(( $BLOCK_OUTBOUND == FALSE ) and
			( $INTERNAL_DHCP == FALSE ) and
			( $MANGLE_TTL == FALSE ) and
			( $PORT_FORWARD == FALSE ) and
			( $TRANSPARENT_PROXY == FALSE )
		) {
			$BLOCK_OUTBOUND_STYLE		= $NO_FW_STYLE;
			$INTERNAL_DHCP_STYLE			= $no_fw_style;
			$MANGLE_TTL_STYLE				= $no_fw_style;
			$PORT_FORWARD_STYLE			= $NO_FW_STYLE;
			$TRANSPARENT_PROXY_STYLE	= $no_fw_style;
			$downloadFW						= FALSE;
		} else {
			// now individual checks
			if(
				( $BLOCK_OUTBOUND and (
					( $EMAIL_OUT == FALSE ) and
					( $FTP_OUT == FALSE ) and
					( $HTTP_OUT == FALSE ) and
					( $IM_OUT == FALSE ) and
					( $IRC_OUT == FALSE ) and
					( $NEWS_OUT == FALSE ) and
					( $SSH_OUT == FALSE ) and
					( $TELNET_OUT == FALSE )
					)
				)
			) {
				$EMAIL_OUT_STYLE			= // deliberately left empty
				$FTP_OUT_STYLE				= // deliberately left empty
				$HTTP_OUT_STYLE			= // deliberately left empty
				$IM_OUT_STYLE				= // deliberately left empty
				$IRC_OUT_STYLE				= // deliberately left empty
				$NEWS_OUT_STYLE			= // deliberately left empty
				$SSH_OUT_STYLE				= // deliberately left empty
				$TELNET_OUT_STYLE			= $no_fw_style;
				$downloadFW					= FALSE;
			}	// if(( $BLOCK_OUTBOUND and ( ... ))) else
			if( $MANGLE_TTL and empty( $TTL )
			) {
				$TTL_STYLE					= $no_fw_style;
				$downloadFW					= FALSE;
			}
			if( $PORT_FORWARD ) {
				if( empty( $PORT_FORWARD_FROM ) or
					(( $PORT_FORWARD_TCP == FALSE ) and ( $PORT_FORWARD_UDP == FALSE ))
				) {
					$PORT_FORWARD_FROM_STYLE	= $no_fw_style;
					$downloadFW						= FALSE;
				}
				if(( empty( $PORT_FORWARD_IP )) or ( preg_match( $IPcheck, $PORT_FORWARD_IP ) === 0 )
				) {
					$PORT_FORWARD_IP_STYLE		= $no_fw_style;
					$downloadFW						= FALSE;
				}
			}	// if( $PORT_FORWARD )
			if( $TRANSPARENT_PROXY and empty( $REDIRECT_PORT )
			) {
				$REDIRECT_PORT_STYLE	= $no_fw_style;
				$downloadFW				= FALSE;
			}
		}	// if(( $BLOCK_OUTBOUND == FALSE ) and ( ... )) else

		$EMAIL_OUT_DISABLED				= ( $BLOCK_OUTBOUND )		? '' : ' disabled';
		$FTP_OUT_DISABLED					= ( $BLOCK_OUTBOUND )		? '' : ' disabled';
		$HTTP_OUT_DISABLED				= ( $BLOCK_OUTBOUND )		? '' : ' disabled';
		$IM_OUT_DISABLED					= ( $BLOCK_OUTBOUND )		? '' : ' disabled';
		$IRC_OUT_DISABLED					= ( $BLOCK_OUTBOUND )		? '' : ' disabled';
		$NEWS_OUT_DISABLED				= ( $BLOCK_OUTBOUND )		? '' : ' disabled';
		$PORT_FORWARD_FROM_DISABLED	= ( $PORT_FORWARD )			? '' : ' disabled';
		$PORT_FORWARD_IP_DISABLED		= ( $PORT_FORWARD )			? '' : ' disabled';
		$PORT_FORWARD_IPORT_DISABLED	= ( $PORT_FORWARD )			? '' : ' disabled';
		$PORT_FORWARD_REDIR_DISABLED	= ( $PORT_FORWARD )			? '' : ' disabled';
		$PORT_FORWARD_TCP_DISABLED		= ( $PORT_FORWARD )			? '' : ' disabled';
		$PORT_FORWARD_TO_DISABLED		= ( $PORT_FORWARD )			? '' : ' disabled';
		$PORT_FORWARD_UDP_DISABLED		= ( $PORT_FORWARD )			? '' : ' disabled';
		$REDIRECT_PORT_DISABLED			= ( $TRANSPARENT_PROXY )	? '' : ' disabled';
		$SSH_OUT_DISABLED					= ( $BLOCK_OUTBOUND )		? '' : ' disabled';
		$TELNET_OUT_DISABLED				= ( $BLOCK_OUTBOUND )		? '' : ' disabled';
		$TTL_DISABLED						= ( $MANGLE_TTL )				? '' : ' disabled';
	} else {	// if( $SPECIAL_LAN )
		$SPECIAL_LAN_CHK					= '';
		$BLOCK_OUTBOUND_DISABLED		= // deliberately left empty
		$EMAIL_OUT_DISABLED				= // deliberately left empty
		$FTP_OUT_DISABLED					= // deliberately left empty
		$INTERNAL_DHCP_DISABLED			= // deliberately left empty
		$MANGLE_TTL_DISABLED				= // deliberately left empty
		$HTTP_OUT_DISABLED				= // deliberately left empty
		$IM_OUT_DISABLED					= // deliberately left empty
		$IRC_OUT_DISABLED					= // deliberately left empty
		$NEWS_OUT_DISABLED				= // deliberately left empty
		$PORT_FORWARD_DISABLED			= // deliberately left empty
		$PORT_FORWARD_FROM_DISABLED	= // deliberately left empty
		$PORT_FORWARD_IP_DISABLED		= // deliberately left empty
		$PORT_FORWARD_IPORT_DISABLED	= // deliberately left empty
		$PORT_FORWARD_REDIR_DISABLED	= // deliberately left empty
		$PORT_FORWARD_TCP_DISABLED		= // deliberately left empty
		$PORT_FORWARD_TO_DISABLED		= // deliberately left empty
		$PORT_FORWARD_UDP_DISABLED		= // deliberately left empty
		$REDIRECT_PORT_DISABLED			= // deliberately left empty
		$SSH_OUT_DISABLED					= // deliberately left empty
		$TELNET_OUT_DISABLED				= // deliberately left empty
		$TRANSPARENT_PROXY_DISABLED	= // deliberately left empty
		$TTL_DISABLED						= ' disabled';
	}	// if( $SPECIAL_LAN ) else

	$BLOCK_OUTBOUND_CHK			= ( $BLOCK_OUTBOUND )		? ' checked' : '';
	$EMAIL_OUT_CHK					= ( $EMAIL_OUT )				? ' checked' : '';
	$FTP_OUT_CHK					= ( $FTP_OUT )					? ' checked' : '';
	$HTTP_OUT_CHK					= ( $HTTP_OUT )				? ' checked' : '';
	$IM_OUT_CHK						= ( $IM_OUT )					? ' checked' : '';
	$INTERNAL_DHCP_CHK			= ( $INTERNAL_DHCP )			? ' checked' : '';
	$IRC_OUT_CHK					= ( $IRC_OUT )					? ' checked' : '';
	$MANGLE_TTL_CHK				= ( $MANGLE_TTL )				? ' checked' : '';
	$NEWS_OUT_CHK					= ( $NEWS_OUT )				? ' checked' : '';
	$PORT_FORWARD_CHK				= ( $PORT_FORWARD )			? ' checked' : '';
	$PORT_FORWARD_REDIR_CHK		= ( $PORT_FORWARD_REDIR )	? ' checked' : '';
	$PORT_FORWARD_TCP_CHK		= ( $PORT_FORWARD_TCP )		? ' checked' : '';
	$PORT_FORWARD_UDP_CHK		= ( $PORT_FORWARD_UDP )		? ' checked' : '';
	$SSH_OUT_CHK					= ( $SSH_OUT )					? ' checked' : '';
	$TELNET_OUT_CHK				= ( $TELNET_OUT )				? ' checked' : '';
	$TRANSPARENT_PROXY_CHK		= ( $TRANSPARENT_PROXY )	? ' checked' : '';

	// inbound services
	if( $INBOUND_ALLOW ) {
		$INBOUND_ALLOW_CHK				= ' checked';

		// at least one checkbox must be selected
		if(( $DHCP_IN == FALSE ) and
			( $DNS_IN == FALSE ) and
			( $IM_IN == FALSE ) and
			( $HTTP_IN == FALSE ) and
			( $FTP_IN == FALSE ) and
			( $PASSIVE_IN == FALSE ) and
			( $EMAIL_IN == FALSE ) and
			( $NTP_IN == FALSE ) and
			( $MDNSRESPONDER_IN == FALSE ) and
			( $MESSENGER_IN == FALSE ) and
			( $NFS_IN == FALSE ) and
			( $OTHER_IN == FALSE ) and
			( $SSH_IN == FALSE )
		) {
			$DHCP_IN_STYLE					= // deliberately left empty
			$DNS_IN_STYLE					= // deliberately left empty
			$EMAIL_IN_STYLE				= // deliberately left empty
			$FTP_IN_STYLE					= // deliberately left empty
			$HTTP_IN_STYLE					= // deliberately left empty
			$IM_IN_STYLE					= // deliberately left empty
			$MDNSRESPONDER_IN_STYLE		= // deliberately left empty
			$MESSENGER_IN_STYLE			= // deliberately left empty
			$NFS_IN_STYLE					= // deliberately left empty
			$NTP_IN_STYLE					= // deliberately left empty
			$OTHER_IN_STYLE				= // deliberately left empty
			$SSH_IN_STYLE					= $no_fw_style;
			$downloadFW						= FALSE;
		} else {	// if(( $DHCP_IN == FALSE ) and ( ... ))
			// now individual checks
			if( $FTP_IN and
				(
					( empty( $PASSIVE_PORT_FROM )) or
					( empty( $PASSIVE_PORT_TO ))
				)
			) {
				$PASSIVE_PORT_FROM_STYLE	= $no_fw_style;
				$downloadFW						= FALSE;
			}
			if( $IM_IN and
				(
					( empty( $IM_PORT_FROM )) or
					( empty( $IM_PORT_TO ))
				)
			) {
				$IM_PORT_FROM_STYLE			= $no_fw_style;
				$downloadFW						= FALSE;
			}
			if( $MESSENGER_IN and
				(
					( empty( $MSN_PORT_FROM )) or
					( empty( $MSN_PORT_TO ))
				)
			) {
				$MSN_PORT_FROM_STYLE			= $no_fw_style;
				$downloadFW						= FALSE;
			}
			if( $OTHER_IN and
				(
					( empty( $OTHER_IN_FROM )) or
					(( $OTHER_IN_TCP == FALSE ) and ( $OTHER_IN_UDP == FALSE ))
				)
			) {
				$OTHER_IN_FROM_STYLE			= $no_fw_style;
				$downloadFW						= FALSE;
			}
			if( $NFS_IN and
				(
					( empty( $LOCKD_PORT )) or
					( empty( $MOUNTD_PORT )) or
					( empty( $RQUOTAD_PORT )) or
					( empty( $STATD_PORT ))
				)
			) {
				$STATD_PORT_STYLE				= $no_fw_style;
				$downloadFW						= FALSE;
			}
		}	// if(( $DHCP_IN == FALSE ) and ( ... )) else

		$IM_PORT_FROM_DISABLED			= ( $IM_IN )					? '' : ' disabled';
		$IM_PORT_TO_DISABLED				= ( $IM_IN )					? '' : ' disabled';
		$LOCKD_PORT_DISABLED				= ( $NFS_IN )					? '' : ' disabled';
		$MOUNTD_PORT_DISABLED			= ( $NFS_IN )					? '' : ' disabled';
		$MSN_PORT_FROM_DISABLED			= ( $MESSENGER_IN )			? '' : ' disabled';
		$MSN_PORT_TO_DISABLED			= ( $MESSENGER_IN )			? '' : ' disabled';
		$OTHER_IN_FROM_DISABLED			= ( $OTHER_IN )				? '' : ' disabled';
		$OTHER_IN_TCP_DISABLED			= ( $OTHER_IN )				? '' : ' disabled';
		$OTHER_IN_TO_DISABLED			= ( $OTHER_IN )				? '' : ' disabled';
		$OTHER_IN_UDP_DISABLED			= ( $OTHER_IN )				? '' : ' disabled';
		$PASSIVE_PORT_FROM_DISABLED	= ( $PASSIVE_IN )				? '' : ' disabled';
		$PASSIVE_PORT_TO_DISABLED		= ( $PASSIVE_IN )				? '' : ' disabled';
		$RQUOTAD_PORT_DISABLED			= ( $NFS_IN )					? '' : ' disabled';
		$STATD_PORT_DISABLED				= ( $NFS_IN )					? '' : ' disabled';
	} else {	// if( $INBOUND_ALLOW )
		$INBOUND_ALLOW_CHK				= '';
		$DHCP_IN_DISABLED					= // deliberately left empty
		$DNS_IN_DISABLED					= // deliberately left empty
		$FTP_IN_DISABLED					= // deliberately left empty
		$EMAIL_IN_DISABLED				= // deliberately left empty
		$EMAILSSL_IN_DISABLED			= // deliberately left empty
		$HTTP_IN_DISABLED					= // deliberately left empty
		$HTTPSSL_IN_DISABLED				= // deliberately left empty
		$IM_IN_DISABLED					= // deliberately left empty
		$IM_PORT_FROM_DISABLED			= // deliberately left empty
		$IM_PORT_TO_DISABLED				= // deliberately left empty
		$LOCKD_PORT_DISABLED				= // deliberately left empty
		$MDNSRESPONDER_IN_DISABLED		= // deliberately left empty
		$MESSENGER_IN_DISABLED			= // deliberately left empty
		$MOUNTD_PORT_DISABLED			= // deliberately left empty
		$MSN_PORT_FROM_DISABLED			= // deliberately left empty
		$MSN_PORT_TO_DISABLED			= // deliberately left empty
		$OTHER_IN_DISABLED				= // deliberately left empty
		$OTHER_IN_FROM_DISABLED			= // deliberately left empty
		$OTHER_IN_TCP_DISABLED			= // deliberately left empty
		$OTHER_IN_TO_DISABLED			= // deliberately left empty
		$OTHER_IN_UDP_DISABLED			= // deliberately left empty
		$NFS_IN_DISABLED					= // deliberately left empty
		$NTP_IN_DISABLED					= // deliberately left empty
		$PASSIVE_IN_DISABLED				= // deliberately left empty
		$PASSIVE_PORT_FROM_DISABLED	= // deliberately left empty
		$PASSIVE_PORT_TO_DISABLED		= // deliberately left empty
		$RQUOTAD_PORT_DISABLED			= // deliberately left empty
		$SSH_IN_DISABLED					= // deliberately left empty
		$STATD_PORT_DISABLED				= ' disabled';
	}	// if( $INBOUND_ALLOW ) else
	$DHCP_IN_CHK					= ( $DHCP_IN )				? ' checked' : '';
	$DNS_IN_CHK						= ( $DNS_IN )				? ' checked' : '';
	$FTP_IN_CHK						= ( $FTP_IN )				? ' checked' : '';
	$EMAIL_IN_CHK					= ( $EMAIL_IN )			? ' checked' : '';
	$EMAILSSL_IN_CHK				= ( $EMAILSSL_IN )		? ' checked' : '';
	$HTTP_IN_CHK					= ( $HTTP_IN )				? ' checked' : '';
	$HTTPSSL_IN_CHK				= ( $HTTPSSL_IN )			? ' checked' : '';
	$IM_IN_CHK						= ( $IM_IN )				? ' checked' : '';
	$MDNSRESPONDER_IN_CHK		= ( $MDNSRESPONDER_IN )	? ' checked' : '';
	$MESSENGER_IN_CHK				= ( $MESSENGER_IN )		? ' checked' : '';
	$NFS_IN_CHK						= ( $NTP_IN )				? ' checked' : '';
	$NTP_IN_CHK						= ( $NTP_IN )				? ' checked' : '';
	$OTHER_IN_CHK					= ( $OTHER_IN )			? ' checked' : '';
	$OTHER_IN_TCP_CHK				= ( $OTHER_IN_TCP )		? ' checked' : '';
	$OTHER_IN_UDP_CHK				= ( $OTHER_IN_UDP )		? ' checked' : '';
	$PASSIVE_IN_CHK				= ( $PASSIVE_IN )			? ' checked' : '';
	$SSH_IN_CHK						= ( $SSH_IN )				? ' checked' : '';
	// log in fireparse format
	$LOG_FIREPARSE_CHK			= ( $LOG_FIREPARSE )		? ' checked' : '';
	// irc user or not
	$IRC_USER_CHK					= ( $IRC_USER )			? ' checked' : '';
	// values for Submit button, entry-tip + js
	$BUTTON_TEXT_NO				= "{$BUTTON_TEXT[$_LANG]} &#10008;";
	$BUTTON_TEXT_YES				= "{$BUTTON_TEXT[$_LANG]} &#10004;";
	$ENTRY_TIP_NO					= $ENTRY_TIP_WHOOPS[ $_LANG ];
	$ENTRY_TIP_YES					= $ENTRY_TIP[ $_LANG ];
	if( !$downloadFW ) { $ENTRY_TIP[ $_LANG ]	= $ENTRY_TIP_WHOOPS[ $_LANG ]; }
	$SUBMIT_TITLE					= ( $downloadFW )			? $BUTTON_TEXT_YES : $BUTTON_TEXT_NO;
	$downloadFW						= ( $SUBMIT )	? $downloadFW	: FALSE;	// do not dl FW if lang change auto-submit
// END complete program-flow template variables (checkbox + dependencies)

	if( !$downloadFW ) {
		// underline labels with Keys
		$BLOCK_OUTBOUND_TITLE[ $_LANG ]		= str_replace(
															$BLOCK_OUTBOUND_KEY[ $_LANG ],
															"<u>{$BLOCK_OUTBOUND_KEY[$_LANG]}</u>",
															$BLOCK_OUTBOUND_TITLE[ $_LANG ]
														);
		$BUTTON_TEXT_NO							= str_replace(
															$SUBMIT_KEY[ $_LANG ],
															"<u>{$SUBMIT_KEY[$_LANG]}</u>",
															$BUTTON_TEXT_NO
														);
		$BUTTON_TEXT_YES							= str_replace(
															$SUBMIT_KEY[ $_LANG ],
															"<u>{$SUBMIT_KEY[$_LANG]}</u>",
															$BUTTON_TEXT_YES
														);
		$DHCP_IN_TITLE[ $_LANG ]				= str_replace(
															$DHCP_IN_KEY[ $_LANG ],
															"<u>{$DHCP_IN_KEY[$_LANG]}</u>",
															$DHCP_IN_TITLE[ $_LANG ]
														);
		$DNS_IN_TITLE[ $_LANG ]					= str_replace(
															$DNS_IN_KEY[ $_LANG ],
															"<u>{$DNS_IN_KEY[$_LANG]}</u>",
															$DNS_IN_TITLE[ $_LANG ]
														);
		$DYNAMIC_IP_NO_TITLE[ $_LANG ]		= str_replace(
															$DYNAMIC_IP_NO_KEY[ $_LANG ],
															"<u>{$DYNAMIC_IP_NO_KEY[$_LANG]}</u>",
															$DYNAMIC_IP_NO_TITLE[ $_LANG ]
														);
		$DYNAMIC_IP_YES_TITLE[ $_LANG ]		= str_replace(
															$DYNAMIC_IP_YES_KEY[ $_LANG ],
															"<u>{$DYNAMIC_IP_YES_KEY[$_LANG]}</u>",
															$DYNAMIC_IP_YES_TITLE[ $_LANG ]
														);
		$EMAIL_IN_TITLE[ $_LANG ]				= str_replace(
															$EMAIL_IN_KEY[ $_LANG ],
															"<u>{$EMAIL_IN_KEY[$_LANG]}</u>",
															$EMAIL_IN_TITLE[ $_LANG ]
														);
		$EMAILSSL_IN_TITLE[ $_LANG ]			= str_replace(
															$EMAILSSL_IN_KEY[ $_LANG ],
															"<u>{$EMAILSSL_IN_KEY[$_LANG]}</u>",
															$EMAILSSL_IN_TITLE[ $_LANG ]
														);
		$EMAIL_OUT_TITLE[ $_LANG ]				= str_replace(
															$EMAIL_OUT_KEY[ $_LANG ],
															"<u>{$EMAIL_OUT_KEY[$_LANG]}</u>",
															$EMAIL_OUT_TITLE[ $_LANG ]
														);
		$FTP_IN_TITLE[ $_LANG ]					= str_replace(
															$FTP_IN_KEY[ $_LANG ],
															"<u>{$FTP_IN_KEY[$_LANG]}</u>",
															$FTP_IN_TITLE[ $_LANG ]
														);
		$FTP_OUT_TITLE[ $_LANG ]				= str_replace(
															$FTP_OUT_KEY[ $_LANG ],
															"<u>{$FTP_OUT_KEY[$_LANG]}</u>",
															$FTP_OUT_TITLE[ $_LANG ]
														);
		$GATEWAY_NO_TITLE[ $_LANG ]			= str_replace(
															$GATEWAY_NO_KEY[ $_LANG ],
															"<u>{$GATEWAY_NO_KEY[$_LANG]}</u>",
															$GATEWAY_NO_TITLE[ $_LANG ]
														);
		$GATEWAY_YES_TITLE[ $_LANG ]			= str_replace(
															$GATEWAY_YES_KEY[ $_LANG ],
															"<u>{$GATEWAY_YES_KEY[$_LANG]}</u>",
															$GATEWAY_YES_TITLE[ $_LANG ]
														);
		$HTTP_IN_TITLE[ $_LANG ]				= str_replace(
															$HTTP_IN_KEY[ $_LANG ],
															"<u>{$HTTP_IN_KEY[$_LANG]}</u>",
															$HTTP_IN_TITLE[ $_LANG ]
														);
		$HTTPSSL_IN_TITLE[ $_LANG ]			= str_replace(
															$HTTPSSL_IN_KEY[ $_LANG ],
															"<u>{$HTTPSSL_IN_KEY[$_LANG]}</u>",
															$HTTPSSL_IN_TITLE[ $_LANG ]
														);
		$HTTP_OUT_TITLE[ $_LANG ]				= str_replace(
															$HTTP_OUT_KEY[ $_LANG ],
															"<u>{$HTTP_OUT_KEY[$_LANG]}</u>",
															$HTTP_OUT_TITLE[ $_LANG ]
														);
		$IM_IN_TITLE[ $_LANG ]					= str_replace(
															$IM_IN_KEY[ $_LANG ],
															"<u>{$IM_IN_KEY[$_LANG]}</u>",
															$IM_IN_TITLE[ $_LANG ]
														);
		$IM_PORT_FROM_TITLE[ $_LANG ]			= str_replace(
															$IM_PORT_FROM_KEY[ $_LANG ],
															"<u>{$IM_PORT_FROM_KEY[$_LANG]}</u>",
															$IM_PORT_FROM_TITLE[ $_LANG ]
														);
		$IM_PORT_TO_TITLE[ $_LANG ]			= str_replace(
															$IM_PORT_TO_KEY[ $_LANG ],
															"<u>{$IM_PORT_TO_KEY[$_LANG]}</u>",
															$IM_PORT_TO_TITLE[ $_LANG ]
														);
		$IM_OUT_TITLE[ $_LANG ]					= str_replace(
															$IM_OUT_KEY[ $_LANG ],
															"<u>{$IM_OUT_KEY[$_LANG]}</u>",
															$IM_OUT_TITLE[ $_LANG ]
														);
		$INBOUND_ALLOW_TITLE[ $_LANG ]		= str_replace(
															$INBOUND_ALLOW_KEY[ $_LANG ],
															"<u>{$INBOUND_ALLOW_KEY[$_LANG]}</u>",
															$INBOUND_ALLOW_TITLE[ $_LANG ]
														);
		$INET_ADDRESS_TITLE[ $_LANG ]			= str_replace(
															$INET_ADDRESS_KEY[ $_LANG ],
															"<u>{$INET_ADDRESS_KEY[$_LANG]}</u>",
															$INET_ADDRESS_TITLE[ $_LANG ]
														);
		$INTERNAL_DHCP_TITLE[ $_LANG ]		= str_replace(
															$INTERNAL_DHCP_KEY[ $_LANG ],
															"<u>{$INTERNAL_DHCP_KEY[$_LANG]}</u>",
															$INTERNAL_DHCP_TITLE[ $_LANG ]
														);
		$IRC_OUT_TITLE[ $_LANG ]				= str_replace(
															$IRC_OUT_KEY[ $_LANG ],
															"<u>{$IRC_OUT_KEY[$_LANG]}</u>",
															$IRC_OUT_TITLE[ $_LANG ]
														);
		$IRC_USER_TITLE[ $_LANG ]				= str_replace(
															$IRC_USER_KEY[ $_LANG ],
															"<u>{$IRC_USER_KEY[$_LANG]}</u>",
															$IRC_USER_TITLE[ $_LANG ]
														);
		$LOCAL_BCAST_TITLE[ $_LANG ]			= str_replace(
															$LOCAL_BCAST_KEY[ $_LANG ],
															"<u>{$LOCAL_BCAST_KEY[$_LANG]}</u>",
															$LOCAL_BCAST_TITLE[ $_LANG ]
														);
		$LOCAL_IFACE_TITLE[ $_LANG ]			= str_replace(
															$LOCAL_IFACE_KEY[ $_LANG ],
															"<u>{$LOCAL_IFACE_KEY[$_LANG]}</u>",
															$LOCAL_IFACE_TITLE[ $_LANG ]
														);
		$LOCAL_IP_TITLE[ $_LANG ]				= str_replace(
															$LOCAL_IP_KEY[ $_LANG ],
															"<u>{$LOCAL_IP_KEY[$_LANG]}</u>",
															$LOCAL_IP_TITLE[ $_LANG ]
														);
		$LOCAL_NET_TITLE[ $_LANG ]				= str_replace(
															$LOCAL_NET_KEY[ $_LANG ],
															"<u>{$LOCAL_NET_KEY[$_LANG]}</u>",
															$LOCAL_NET_TITLE[ $_LANG ]
														);
		$LOCKD_PORT_TITLE[ $_LANG ]			= str_replace(
															$LOCKD_PORT_KEY[ $_LANG ],
															"<u>{$LOCKD_PORT_KEY[$_LANG]}</u>",
															$LOCKD_PORT_TITLE[ $_LANG ]
														);
		$LOG_FIREPARSE_TITLE[ $_LANG ]		= str_replace(
															$LOG_FIREPARSE_KEY[ $_LANG ],
															"<u>{$LOG_FIREPARSE_KEY[$_LANG]}</u>",
															$LOG_FIREPARSE_TITLE[ $_LANG ]
														);
		$MANGLE_TTL_TITLE[ $_LANG ]			= str_replace(
															$MANGLE_TTL_KEY[ $_LANG ],
															"<u>{$MANGLE_TTL_KEY[$_LANG]}</u>",
															$MANGLE_TTL_TITLE[ $_LANG ]
														);
		$MDNSRESPONDER_IN_TITLE[ $_LANG ]	= str_replace(
															$MDNSRESPONDER_IN_KEY[ $_LANG ],
															"<u>{$MDNSRESPONDER_IN_KEY[$_LANG]}</u>",
															$MDNSRESPONDER_IN_TITLE[ $_LANG ]
														);
		$MESSENGER_IN_TITLE[ $_LANG ]			= str_replace(
															$MESSENGER_IN_KEY[ $_LANG ],
															"<u>{$MESSENGER_IN_KEY[$_LANG]}</u>",
															$MESSENGER_IN_TITLE[ $_LANG ]
														);
		$MOUNTD_PORT_TITLE[ $_LANG ]			= str_replace(
															$MOUNTD_PORT_KEY[ $_LANG ],
															"<u>{$MOUNTD_PORT_KEY[$_LANG]}</u>",
															$MOUNTD_PORT_TITLE[ $_LANG ]
														);
		$MSN_PORT_FROM_TITLE[ $_LANG ]		= str_replace(
															$MSN_PORT_FROM_KEY[ $_LANG ],
															"<u>{$MSN_PORT_FROM_KEY[$_LANG]}</u>",
															$MSN_PORT_FROM_TITLE[ $_LANG ]
														);
		$MSN_PORT_TO_TITLE[ $_LANG ]			= str_replace(
															$MSN_PORT_TO_KEY[ $_LANG ],
															"<u>{$MSN_PORT_TO_KEY[$_LANG]}</u>",
															$MSN_PORT_TO_TITLE[ $_LANG ]
														);
		$NEWS_OUT_TITLE[ $_LANG ]				= str_replace(
															$NEWS_OUT_KEY[ $_LANG ],
															"<u>{$NEWS_OUT_KEY[$_LANG]}</u>",
															$NEWS_OUT_TITLE[ $_LANG ]
														);
		$NFS_IN_TITLE[ $_LANG ]					= str_replace(
															$NFS_IN_KEY[ $_LANG ],
															"<u>{$NFS_IN_KEY[$_LANG]}</u>",
															$NFS_IN_TITLE[ $_LANG ]
														);
		$NTP_IN_TITLE[ $_LANG ]					= str_replace(
															$NTP_IN_KEY[ $_LANG ],
															"<u>{$NTP_IN_KEY[$_LANG]}</u>",
															$NTP_IN_TITLE[ $_LANG ]
														);
		$OTHER_IN_TITLE[ $_LANG ]				= str_replace(
															$OTHER_IN_KEY[ $_LANG ],
															"<u>{$OTHER_IN_KEY[$_LANG]}</u>",
															$OTHER_IN_TITLE[ $_LANG ]
														);
		$OTHER_IN_FROM_TITLE[ $_LANG ]		= str_replace(
															$OTHER_IN_FROM_KEY[ $_LANG ],
															"<u>{$OTHER_IN_FROM_KEY[$_LANG]}</u>",
															$OTHER_IN_FROM_TITLE[ $_LANG ]
														);
		$OTHER_IN_TO_TITLE[ $_LANG ]			= str_replace(
															$OTHER_IN_TO_KEY[ $_LANG ],
															"<u>{$OTHER_IN_TO_KEY[$_LANG]}</u>",
															$OTHER_IN_TO_TITLE[ $_LANG ]
														);
		$PORT_FORWARD_FROM_TITLE[ $_LANG ]	= str_replace(
															$PORT_FORWARD_FROM_KEY[ $_LANG ],
															"<u>{$PORT_FORWARD_FROM_KEY[$_LANG]}</u>",
															$PORT_FORWARD_FROM_TITLE[ $_LANG ]
														);
		$PORT_FORWARD_IP_TITLE[ $_LANG ]		= str_replace(
															$PORT_FORWARD_IP_KEY[ $_LANG ],
															"<u>{$PORT_FORWARD_IP_KEY[$_LANG]}</u>",
															$PORT_FORWARD_IP_TITLE[ $_LANG ]
														);
		$PORT_FORWARD_IPORT_TITLE[ $_LANG ]	= str_replace(
															$PORT_FORWARD_IPORT_KEY[ $_LANG ],
															"<u>{$PORT_FORWARD_IPORT_KEY[$_LANG]}</u>",
															$PORT_FORWARD_IPORT_TITLE[ $_LANG ]
														);
		$PORT_FORWARD_REDIR_TITLE[ $_LANG ]	= str_replace(
															$PORT_FORWARD_REDIR_KEY[ $_LANG ],
															"<u>{$PORT_FORWARD_REDIR_KEY[$_LANG]}</u>",
															$PORT_FORWARD_REDIR_TITLE[ $_LANG ]
														);
		$PORT_FORWARD_TITLE[ $_LANG ]			= str_replace(
															$PORT_FORWARD_KEY[ $_LANG ],
															"<u>{$PORT_FORWARD_KEY[$_LANG]}</u>",
															$PORT_FORWARD_TITLE[ $_LANG ]
														);
		$PORT_FORWARD_TO_TITLE[ $_LANG ]		= str_replace(
															$PORT_FORWARD_TO_KEY[ $_LANG ],
															"<u>{$PORT_FORWARD_TO_KEY[$_LANG]}</u>",
															$PORT_FORWARD_TO_TITLE[ $_LANG ]
														);
		$REDIRECT_PORT_TITLE[ $_LANG ]		= str_replace(
															$REDIRECT_PORT_KEY[ $_LANG ],
															"<u>{$REDIRECT_PORT_KEY[$_LANG]}</u>",
															$REDIRECT_PORT_TITLE[ $_LANG ]
														);
		$RQUOTAD_PORT_TITLE[ $_LANG ]			= str_replace(
															$RQUOTAD_PORT_KEY[ $_LANG ],
															"<u>{$RQUOTAD_PORT_KEY[$_LANG]}</u>",
															$RQUOTAD_PORT_TITLE[ $_LANG ]
														);
		$SSH_IN_TITLE[ $_LANG ]					= str_replace(
															$SSH_IN_KEY[ $_LANG ],
															"<u>{$SSH_IN_KEY[$_LANG]}</u>",
															$SSH_IN_TITLE[ $_LANG ]
														);
		$SSH_OUT_TITLE[ $_LANG ]				= str_replace(
															$SSH_OUT_KEY[ $_LANG ],
															"<u>{$SSH_OUT_KEY[$_LANG]}</u>",
															$SSH_OUT_TITLE[ $_LANG ]
														);
		$STATD_PORT_TITLE[ $_LANG ]			= str_replace(
															$STATD_PORT_KEY[ $_LANG ],
															"<u>{$STATD_PORT_KEY[$_LANG]}</u>",
															$STATD_PORT_TITLE[ $_LANG ]
														);
		$SPECIAL_LAN_TITLE[ $_LANG ]			= str_replace(
															$SPECIAL_LAN_KEY[ $_LANG ],
															"<u>{$SPECIAL_LAN_KEY[$_LANG]}</u>",
															$SPECIAL_LAN_TITLE[ $_LANG ]
														);
		$SUBMIT_TITLE								= str_replace(
															$SUBMIT_KEY[ $_LANG ],
															"<u>{$SUBMIT_KEY[$_LANG]}</u>",
															$SUBMIT_TITLE
														);
		$TELNET_OUT_TITLE[ $_LANG ]			= str_replace(
															$TELNET_OUT_KEY[ $_LANG ],
															"<u>{$TELNET_OUT_KEY[$_LANG]}</u>",
															$TELNET_OUT_TITLE[ $_LANG ]
														);
		$TRANSPARENT_PROXY_TITLE[ $_LANG ]	= str_replace(
															$TRANSPARENT_PROXY_KEY[ $_LANG ],
															"<u>{$TRANSPARENT_PROXY_KEY[$_LANG]}</u>",
															$TRANSPARENT_PROXY_TITLE[ $_LANG ]
														);
		$TTL_TITLE[ $_LANG ]						= str_replace(
															$TTL_KEY[ $_LANG ],
															"<u>{$TTL_KEY[$_LANG]}</u>",
															$TTL_TITLE[ $_LANG ]
														);

		$Template->assign_vars( array(
			'A_INDEX'							=> A_INDEX,
			'BLOCK_OUTBOUND_CHK'				=> $BLOCK_OUTBOUND_CHK,
			'BLOCK_OUTBOUND_DISABLED'		=> $BLOCK_OUTBOUND_DISABLED,
			'BLOCK_OUTBOUND_KEY'				=> $BLOCK_OUTBOUND_KEY[ $_LANG ],
			'BLOCK_OUTBOUND_TITLE'			=> $BLOCK_OUTBOUND_TITLE[ $_LANG ],
			'BLOCK_OUTBOUND_STYLE'			=> $BLOCK_OUTBOUND_STYLE,
			'BUTTON_TEXT_NO'					=> $BUTTON_TEXT_NO,
			'BUTTON_TEXT_YES'					=> $BUTTON_TEXT_YES,
			'DHCP_IN_CHK'						=> $DHCP_IN_CHK,
			'DHCP_IN_DISABLED'				=> $DHCP_IN_DISABLED,
			'DHCP_IN_KEY'						=> $DHCP_IN_KEY[ $_LANG ],
			'DHCP_IN_TITLE'					=> $DHCP_IN_TITLE[ $_LANG ],
			'DHCP_IN_STYLE'					=> $DHCP_IN_STYLE,
			'DNS_IN_CHK'						=> $DNS_IN_CHK,
			'DNS_IN_DISABLED'					=> $DNS_IN_DISABLED,
			'DNS_IN_KEY'						=> $DNS_IN_KEY[ $_LANG ],
			'DNS_IN_TITLE'						=> $DNS_IN_TITLE[ $_LANG ],
			'DNS_IN_STYLE'						=> $DNS_IN_STYLE,
			'DYNAMIC_IP_NO_CHK'				=> $DYNAMIC_IP_NO_CHK,
			'DYNAMIC_IP_NO_KEY'				=> $DYNAMIC_IP_NO_KEY[ $_LANG ],
			'DYNAMIC_IP_NO_TITLE'			=> $DYNAMIC_IP_NO_TITLE[ $_LANG ],
			'DYNAMIC_IP_TITLE'				=> $DYNAMIC_IP_TITLE[ $_LANG ],
			'DYNAMIC_IP_YES_CHK'				=> $DYNAMIC_IP_YES_CHK,
			'DYNAMIC_IP_YES_KEY'				=> $DYNAMIC_IP_YES_KEY[ $_LANG ],
			'DYNAMIC_IP_YES_TITLE'			=> $DYNAMIC_IP_YES_TITLE[ $_LANG ],
			'EMAIL_IN_CHK'						=> $EMAIL_IN_CHK,
			'EMAIL_IN_DISABLED'				=> $EMAIL_IN_DISABLED,
			'EMAIL_IN_KEY'						=> $EMAIL_IN_KEY[ $_LANG ],
			'EMAIL_IN_TITLE'					=> $EMAIL_IN_TITLE[ $_LANG ],
			'EMAIL_IN_STYLE'					=> $EMAIL_IN_STYLE,
			'EMAIL_OUT_CHK'					=> $EMAIL_OUT_CHK,
			'EMAIL_OUT_DISABLED'				=> $EMAIL_OUT_DISABLED,
			'EMAIL_OUT_KEY'					=> $EMAIL_OUT_KEY[ $_LANG ],
			'EMAIL_OUT_TITLE'					=> $EMAIL_OUT_TITLE[ $_LANG ],
			'EMAIL_OUT_STYLE'					=> $EMAIL_OUT_STYLE,
			'EMAILSSL_IN_CHK'					=> $EMAILSSL_IN_CHK,
			'EMAILSSL_IN_DISABLED'			=> $EMAILSSL_IN_DISABLED,
			'EMAILSSL_IN_KEY'					=> $EMAILSSL_IN_KEY[ $_LANG ],
			'EMAILSSL_IN_TITLE'				=> $EMAILSSL_IN_TITLE[ $_LANG ],
			'ENTRY_TIP'							=> $ENTRY_TIP[ $_LANG ],
			'ENTRY_TIP_NO'						=> $ENTRY_TIP_NO,
			'ENTRY_TIP_YES'					=> $ENTRY_TIP_YES,
			'FTP_IN_CHK'						=> $FTP_IN_CHK,
			'FTP_IN_DISABLED'					=> $FTP_IN_DISABLED,
			'FTP_IN_KEY'						=> $FTP_IN_KEY[ $_LANG ],
			'FTP_IN_TITLE'						=> $FTP_IN_TITLE[ $_LANG ],
			'FTP_IN_STYLE'						=> $FTP_IN_STYLE,
			'FTP_OUT_CHK'						=> $FTP_OUT_CHK,
			'FTP_OUT_DISABLED'				=> $FTP_OUT_DISABLED,
			'FTP_OUT_KEY'						=> $FTP_OUT_KEY[ $_LANG ],
			'FTP_OUT_TITLE'					=> $FTP_OUT_TITLE[ $_LANG ],
			'FTP_OUT_STYLE'					=> $FTP_OUT_STYLE,
			'G_POPUP_WARN'						=> $G_POPUP_WARN,
			'G_STYLE_DL_NO'					=> $G_STYLE_DL_NO,
			'G_STYLE_DL_YES'					=> $G_STYLE_DL_YES,
			'GATEWAY_NO_TITLE'				=> $GATEWAY_NO_TITLE[ $_LANG ],
			'GATEWAY_NO_CHK'					=> $GATEWAY_NO_CHK,
			'GATEWAY_NO_KEY'					=> $GATEWAY_NO_KEY[ $_LANG ],
			'GATEWAY_TITLE'					=> $GATEWAY_TITLE[ $_LANG ],
			'GATEWAY_YES_TITLE'				=> $GATEWAY_YES_TITLE[ $_LANG ],
			'GATEWAY_YES_CHK'					=> $GATEWAY_YES_CHK,
			'GATEWAY_YES_KEY'					=> $GATEWAY_YES_KEY[ $_LANG ],
			'HELP'								=> $HELP[ $_LANG ],
			'HELP_TXT'							=> $HELP_TXT[ $_LANG ],
			'HTTP_IN_CHK'						=> $HTTP_IN_CHK,
			'HTTP_IN_DISABLED'				=> $HTTP_IN_DISABLED,
			'HTTP_IN_KEY'						=> $HTTP_IN_KEY[ $_LANG ],
			'HTTP_IN_TITLE'					=> $HTTP_IN_TITLE[ $_LANG ],
			'HTTP_IN_STYLE'					=> $HTTP_IN_STYLE,
			'HTTP_OUT_CHK'						=> $HTTP_OUT_CHK,
			'HTTP_OUT_DISABLED'				=> $HTTP_OUT_DISABLED,
			'HTTP_OUT_KEY'						=> $HTTP_OUT_KEY[ $_LANG ],
			'HTTP_OUT_TITLE'					=> $HTTP_OUT_TITLE[ $_LANG ],
			'HTTP_OUT_STYLE'					=> $HTTP_OUT_STYLE,
			'HTTPSSL_IN_CHK'					=> $HTTPSSL_IN_CHK,
			'HTTPSSL_IN_DISABLED'			=> $HTTPSSL_IN_DISABLED,
			'HTTPSSL_IN_KEY'					=> $HTTPSSL_IN_KEY[ $_LANG ],
			'HTTPSSL_IN_TITLE'				=> $HTTPSSL_IN_TITLE[ $_LANG ],
			'IM_IN_CHK'							=> $IM_IN_CHK,
			'IM_IN_DISABLED'					=> $IM_IN_DISABLED,
			'IM_IN_KEY'							=> $IM_IN_KEY[ $_LANG ],
			'IM_IN_TITLE'						=> $IM_IN_TITLE[ $_LANG ],
			'IM_IN_STYLE'						=> $IM_IN_STYLE,
			'IM_OUT_CHK'						=> $IM_OUT_CHK,
			'IM_OUT_DISABLED'					=> $IM_OUT_DISABLED,
			'IM_OUT_KEY'						=> $IM_OUT_KEY[ $_LANG ],
			'IM_OUT_TITLE'						=> $IM_OUT_TITLE[ $_LANG ],
			'IM_OUT_STYLE'						=> $IM_OUT_STYLE,
			'IM_PORT_FROM'						=> $IM_PORT_FROM,
			'IM_PORT_FROM_DISABLED'			=> $IM_PORT_FROM_DISABLED,
			'IM_PORT_FROM_KEY'				=> $IM_PORT_FROM_KEY[ $_LANG ],
			'IM_PORT_FROM_TITLE'				=> $IM_PORT_FROM_TITLE[ $_LANG ],
			'IM_PORT_FROM_STYLE'				=> $IM_PORT_FROM_STYLE,
			'IM_PORT_TO'						=> $IM_PORT_TO,
			'IM_PORT_TO_DISABLED'			=> $IM_PORT_TO_DISABLED,
			'IM_PORT_TO_KEY'					=> $IM_PORT_TO_KEY[ $_LANG ],
			'IM_PORT_TO_TITLE'				=> $IM_PORT_TO_TITLE[ $_LANG ],
			'INBOUND_ALLOW_CHK'				=> $INBOUND_ALLOW_CHK,
			'INBOUND_ALLOW_KEY'				=> $INBOUND_ALLOW_KEY[ $_LANG ],
			'INBOUND_ALLOW_TITLE'			=> $INBOUND_ALLOW_TITLE[ $_LANG ],
			'INET_ADDRESS'						=> $INET_ADDRESS,
			'INET_ADDRESS_DISABLED'			=> $INET_ADDRESS_DISABLED,
			'INET_ADDRESS_KEY'				=> $INET_ADDRESS_KEY[ $_LANG ],
			'INET_ADDRESS_STYLE'				=> $INET_ADDRESS_STYLE,
			'INET_ADDRESS_TITLE'				=> $INET_ADDRESS_TITLE[ $_LANG ],
			'INET_IFACE'						=> $INET_IFACE,
			'INET_IFACE_TITLE'				=> $INET_IFACE_TITLE[ $_LANG ],
			'INTERNAL_DHCP_CHK'				=> $INTERNAL_DHCP_CHK,
			'INTERNAL_DHCP_DISABLED'		=> $INTERNAL_DHCP_DISABLED,
			'INTERNAL_DHCP_KEY'				=> $INTERNAL_DHCP_KEY[ $_LANG ],
			'INTERNAL_DHCP_TITLE'			=> $INTERNAL_DHCP_TITLE[ $_LANG ],
			'INTERNAL_DHCP_STYLE'			=> $INTERNAL_DHCP_STYLE,
			'IRC_OUT_CHK'						=> $IRC_OUT_CHK,
			'IRC_OUT_DISABLED'				=> $IRC_OUT_DISABLED,
			'IRC_OUT_KEY'						=> $IRC_OUT_KEY[ $_LANG ],
			'IRC_OUT_TITLE'					=> $IRC_OUT_TITLE[ $_LANG ],
			'IRC_OUT_STYLE'					=> $IRC_OUT_STYLE,
			'IRC_USER_CHK'						=> $IRC_USER_CHK,
			'IRC_USER_KEY'						=> $IRC_USER_KEY[ $_LANG ],
			'IRC_USER_TITLE'					=> $IRC_USER_TITLE[ $_LANG ],
			'L_INDEX'							=> L_INDEX,
			'L_POST'								=> $L_POST[ $_LANG ],
			'L_SUBMIT'							=> $L_SUBMIT[ $_LANG ],
			'L_VIEW_NAV'						=> $L_VIEW_NAV,
			'LANG_OPTIONS'						=> $LANG_OPTIONS,
			'LOCAL_BCAST'						=> $LOCAL_BCAST,
			'LOCAL_BCAST_DISABLED'			=> $LOCAL_BCAST_DISABLED,
			'LOCAL_BCAST_KEY'					=> $LOCAL_BCAST_KEY[ $_LANG ],
			'LOCAL_BCAST_TITLE'				=> $LOCAL_BCAST_TITLE[ $_LANG ],
			'LOCAL_BCAST_STYLE'				=> $LOCAL_BCAST_STYLE,
			'LOCAL_IFACE'						=> $LOCAL_IFACE,
			'LOCAL_IFACE_DISABLED'			=> $LOCAL_IFACE_DISABLED,
			'LOCAL_IFACE_KEY'					=> $LOCAL_IFACE_KEY[ $_LANG ],
			'LOCAL_IFACE_TITLE'				=> $LOCAL_IFACE_TITLE[ $_LANG ],
			'LOCAL_IFACE_STYLE'				=> $LOCAL_IFACE_STYLE,
			'LOCAL_IP'							=> $LOCAL_IP,
			'LOCAL_IP_DISABLED'				=> $LOCAL_IP_DISABLED,
			'LOCAL_IP_KEY'						=> $LOCAL_IP_KEY[ $_LANG ],
			'LOCAL_IP_TITLE'					=> $LOCAL_IP_TITLE[ $_LANG ],
			'LOCAL_IP_STYLE'					=> $LOCAL_IP_STYLE,
			'LOCAL_NET'							=> $LOCAL_NET,
			'LOCAL_NET_DISABLED'				=> $LOCAL_NET_DISABLED,
			'LOCAL_NET_KEY'					=> $LOCAL_NET_KEY[ $_LANG ],
			'LOCAL_NET_TITLE'					=> $LOCAL_NET_TITLE[ $_LANG ],
			'LOCAL_NET_STYLE'					=> $LOCAL_NET_STYLE,
			'LOCKD_PORT'						=> $LOCKD_PORT,
			'LOCKD_PORT_DISABLED'			=> $LOCKD_PORT_DISABLED,
			'LOCKD_PORT_KEY'					=> $LOCKD_PORT_KEY[ $_LANG ],
			'LOCKD_PORT_TITLE'				=> $LOCKD_PORT_TITLE[ $_LANG ],
			'LOG_FIREPARSE_CHK'				=> $LOG_FIREPARSE_CHK,
			'LOG_FIREPARSE_KEY'				=> $LOG_FIREPARSE_KEY[ $_LANG ],
			'LOG_FIREPARSE_TITLE'			=> $LOG_FIREPARSE_TITLE[ $_LANG ],
			'MANGLE_TTL_CHK'					=> $MANGLE_TTL_CHK,
			'MANGLE_TTL_DISABLED'			=> $MANGLE_TTL_DISABLED,
			'MANGLE_TTL_KEY'					=> $MANGLE_TTL_KEY[ $_LANG ],
			'MANGLE_TTL_TITLE'				=> $MANGLE_TTL_TITLE[ $_LANG ],
			'MANGLE_TTL_STYLE'				=> $MANGLE_TTL_STYLE,
			'MDNSRESPONDER_IN_CHK'			=> $MDNSRESPONDER_IN_CHK,
			'MDNSRESPONDER_IN_DISABLED'	=> $MDNSRESPONDER_IN_DISABLED,
			'MDNSRESPONDER_IN_KEY'			=> $MDNSRESPONDER_IN_KEY[ $_LANG ],
			'MDNSRESPONDER_IN_TITLE'		=> $MDNSRESPONDER_IN_TITLE[ $_LANG ],
			'MDNSRESPONDER_IN_STYLE'		=> $MDNSRESPONDER_IN_STYLE,
			'MESSENGER_IN_CHK'				=> $MESSENGER_IN_CHK,
			'MESSENGER_IN_DISABLED'			=> $MESSENGER_IN_DISABLED,
			'MESSENGER_IN_KEY'				=> $MESSENGER_IN_KEY[ $_LANG ],
			'MESSENGER_IN_TITLE'				=> $MESSENGER_IN_TITLE[ $_LANG ],
			'MESSENGER_IN_STYLE'				=> $MESSENGER_IN_STYLE,
			'META'								=> $META,
			'MOUNTD_PORT'						=> $MOUNTD_PORT,
			'MOUNTD_PORT_DISABLED'			=> $MOUNTD_PORT_DISABLED,
			'MOUNTD_PORT_KEY'					=> $MOUNTD_PORT_KEY[ $_LANG ],
			'MOUNTD_PORT_TITLE'				=> $MOUNTD_PORT_TITLE[ $_LANG ],
			'MSN_PORT_FROM'					=> $MSN_PORT_FROM,
			'MSN_PORT_FROM_DISABLED'		=> $MSN_PORT_FROM_DISABLED,
			'MSN_PORT_FROM_KEY'				=> $MSN_PORT_FROM_KEY[ $_LANG ],
			'MSN_PORT_FROM_TITLE'			=> $MSN_PORT_FROM_TITLE[ $_LANG ],
			'MSN_PORT_FROM_STYLE'			=> $MSN_PORT_FROM_STYLE,
			'MSN_PORT_TO'						=> $MSN_PORT_TO,
			'MSN_PORT_TO_DISABLED'			=> $MSN_PORT_TO_DISABLED,
			'MSN_PORT_TO_KEY'					=> $MSN_PORT_TO_KEY[ $_LANG ],
			'MSN_PORT_TO_TITLE'				=> $MSN_PORT_TO_TITLE[ $_LANG ],
			'NAV_LINKS'							=> $NAV_LINKS,
			'NEWS_OUT_CHK'						=> $NEWS_OUT_CHK,
			'NEWS_OUT_DISABLED'				=> $NEWS_OUT_DISABLED,
			'NEWS_OUT_KEY'						=> $NEWS_OUT_KEY[ $_LANG ],
			'NEWS_OUT_TITLE'					=> $NEWS_OUT_TITLE[ $_LANG ],
			'NEWS_OUT_STYLE'					=> $NEWS_OUT_STYLE,
			'NO_FW_STYLE'						=> $NO_FW_STYLE,
			'NFS_IN_CHK'						=> $NFS_IN_CHK,
			'NFS_IN_DISABLED'					=> $NFS_IN_DISABLED,
			'NFS_IN_KEY'						=> $NFS_IN_KEY[ $_LANG ],
			'NFS_IN_TITLE'						=> $NFS_IN_TITLE[ $_LANG ],
			'NFS_IN_STYLE'						=> $NFS_IN_STYLE,
			'NTP_IN_CHK'						=> $NTP_IN_CHK,
			'NTP_IN_DISABLED'					=> $NTP_IN_DISABLED,
			'NTP_IN_KEY'						=> $NTP_IN_KEY[ $_LANG ],
			'NTP_IN_TITLE'						=> $NTP_IN_TITLE[ $_LANG ],
			'NTP_IN_STYLE'						=> $NTP_IN_STYLE,
			'OTHER_IN_CHK'						=> $OTHER_IN_CHK,
			'OTHER_IN_DISABLED'				=> $OTHER_IN_DISABLED,
			'OTHER_IN_KEY'						=> $OTHER_IN_KEY[ $_LANG ],
			'OTHER_IN_TITLE'					=> $OTHER_IN_TITLE[ $_LANG ],
			'OTHER_IN_FROM'					=> $OTHER_IN_FROM,
			'OTHER_IN_FROM_DISABLED'		=> $OTHER_IN_FROM_DISABLED,
			'OTHER_IN_FROM_KEY'				=> $OTHER_IN_FROM_KEY[ $_LANG ],
			'OTHER_IN_FROM_TITLE'			=> $OTHER_IN_FROM_TITLE[ $_LANG ],
			'OTHER_IN_FROM_STYLE'			=> $OTHER_IN_FROM_STYLE,
			'OTHER_IN_STYLE'					=> $OTHER_IN_STYLE,
			'OTHER_IN_TCP_CHK'				=> $OTHER_IN_TCP_CHK,
			'OTHER_IN_TCP_DISABLED'			=> $OTHER_IN_TCP_DISABLED,
			'OTHER_IN_TCP_TITLE'				=> $OTHER_IN_TCP_TITLE[ $_LANG ],
			'OTHER_IN_TO'						=> $OTHER_IN_TO,
			'OTHER_IN_TO_DISABLED'			=> $OTHER_IN_TO_DISABLED,
			'OTHER_IN_TO_KEY'					=> $OTHER_IN_TO_KEY[ $_LANG ],
			'OTHER_IN_TO_TITLE'				=> $OTHER_IN_TO_TITLE[ $_LANG ],
			'OTHER_IN_UDP_CHK'				=> $OTHER_IN_UDP_CHK,
			'OTHER_IN_UDP_DISABLED'			=> $OTHER_IN_UDP_DISABLED,
			'OTHER_IN_UDP_TITLE'				=> $OTHER_IN_UDP_TITLE[ $_LANG ],
			'PAGE_TITLE'						=> $PAGE_TITLE[ $_LANG ],
			'PASSIVE_IN_CHK'					=> $PASSIVE_IN_CHK,
			'PASSIVE_IN_DISABLED'			=> $PASSIVE_IN_DISABLED,
			'PASSIVE_IN_KEY'					=> $PASSIVE_IN_KEY[ $_LANG ],
			'PASSIVE_IN_TITLE'				=> $PASSIVE_IN_TITLE[ $_LANG ],
			'PASSIVE_PORT_FROM'				=> $PASSIVE_PORT_FROM,
			'PASSIVE_PORT_FROM_DISABLED'	=> $PASSIVE_PORT_FROM_DISABLED,
			'PASSIVE_PORT_FROM_KEY'			=> $PASSIVE_PORT_FROM_KEY[ $_LANG ],
			'PASSIVE_PORT_FROM_TITLE'		=> $PASSIVE_PORT_FROM_TITLE[ $_LANG ],
			'PASSIVE_PORT_FROM_STYLE'		=> $PASSIVE_PORT_FROM_STYLE,
			'PASSIVE_PORT_TO'					=> $PASSIVE_PORT_TO,
			'PASSIVE_PORT_TO_DISABLED'		=> $PASSIVE_PORT_TO_DISABLED,
			'PASSIVE_PORT_TO_KEY'			=> $PASSIVE_PORT_TO_KEY[ $_LANG ],
			'PASSIVE_PORT_TO_TITLE'			=> $PASSIVE_PORT_TO_TITLE[ $_LANG ],
			'PORT_FORWARD_CHK'				=> $PORT_FORWARD_CHK,
			'PORT_FORWARD_DISABLED'			=> $PORT_FORWARD_DISABLED,
			'PORT_FORWARD_KEY'				=> $PORT_FORWARD_KEY[ $_LANG ],
			'PORT_FORWARD_FROM'				=> $PORT_FORWARD_FROM,
			'PORT_FORWARD_FROM_DISABLED'	=> $PORT_FORWARD_FROM_DISABLED,
			'PORT_FORWARD_FROM_KEY'			=> $PORT_FORWARD_FROM_KEY[ $_LANG ],
			'PORT_FORWARD_FROM_TITLE'		=> $PORT_FORWARD_FROM_TITLE[ $_LANG ],
			'PORT_FORWARD_FROM_STYLE'		=> $PORT_FORWARD_FROM_STYLE,
			'PORT_FORWARD_IP'					=> $PORT_FORWARD_IP,
			'PORT_FORWARD_IP_KEY'			=> $PORT_FORWARD_IP_KEY[ $_LANG ],
			'PORT_FORWARD_IP_DISABLED'		=> $PORT_FORWARD_IP_DISABLED,
			'PORT_FORWARD_IP_TITLE'			=> $PORT_FORWARD_IP_TITLE[ $_LANG ],
			'PORT_FORWARD_IP_STYLE'			=> $PORT_FORWARD_IP_STYLE,
			'PORT_FORWARD_IPORT'				=> $PORT_FORWARD_IPORT,
			'PORT_FORWARD_IPORT_KEY'		=> $PORT_FORWARD_IPORT_KEY[ $_LANG ],
			'PORT_FORWARD_IPORT_DISABLED'	=> $PORT_FORWARD_IPORT_DISABLED,
			'PORT_FORWARD_IPORT_TITLE'		=> $PORT_FORWARD_IPORT_TITLE[ $_LANG ],
			'PORT_FORWARD_REDIR_CHK'		=> $PORT_FORWARD_REDIR_CHK,
			'PORT_FORWARD_REDIR_DISABLED'	=> $PORT_FORWARD_REDIR_DISABLED,
			'PORT_FORWARD_REDIR_KEY'		=> $PORT_FORWARD_REDIR_KEY[ $_LANG ],
			'PORT_FORWARD_REDIR_TITLE'		=> $PORT_FORWARD_REDIR_TITLE[ $_LANG ],
			'PORT_FORWARD_STYLE'				=> $PORT_FORWARD_STYLE,
			'PORT_FORWARD_TCP_CHK'			=> $PORT_FORWARD_TCP_CHK,
			'PORT_FORWARD_TCP_DISABLED'	=> $PORT_FORWARD_TCP_DISABLED,
			'PORT_FORWARD_TITLE'				=> $PORT_FORWARD_TITLE[ $_LANG ],
			'PORT_FORWARD_TO'					=> $PORT_FORWARD_TO,
			'PORT_FORWARD_TO_DISABLED'		=> $PORT_FORWARD_TO_DISABLED,
			'PORT_FORWARD_TO_KEY'			=> $PORT_FORWARD_TO_KEY[ $_LANG ],
			'PORT_FORWARD_TO_TITLE'			=> $PORT_FORWARD_TO_TITLE[ $_LANG ],
			'PORT_FORWARD_TCP_TITLE'		=> $PORT_FORWARD_TCP_TITLE,
			'PORT_FORWARD_UDP_CHK'			=> $PORT_FORWARD_UDP_CHK,
			'PORT_FORWARD_UDP_DISABLED'	=> $PORT_FORWARD_UDP_DISABLED,
			'PORT_FORWARD_UDP_TITLE'		=> $PORT_FORWARD_UDP_TITLE,
			'REDIRECT_PORT'					=> $REDIRECT_PORT,
			'REDIRECT_PORT_DISABLED'		=> $REDIRECT_PORT_DISABLED,
			'REDIRECT_PORT_KEY'				=> $REDIRECT_PORT_KEY[ $_LANG ],
			'REDIRECT_PORT_TITLE'			=> $REDIRECT_PORT_TITLE[ $_LANG ],
			'REDIRECT_PORT_STYLE'			=> $REDIRECT_PORT_STYLE,
			'RQUOTAD_PORT'						=> $RQUOTAD_PORT,
			'RQUOTAD_PORT_DISABLED'			=> $RQUOTAD_PORT_DISABLED,
			'RQUOTAD_PORT_KEY'				=> $RQUOTAD_PORT_KEY[ $_LANG ],
			'RQUOTAD_PORT_TITLE'				=> $RQUOTAD_PORT_TITLE[ $_LANG ],
			'S_CONTENT_DIRECTION'			=> $S_CONTENT_DIRECTION[ $_LANG ],
			'S_CONTENT_ENCODING'				=> $S_CONTENT_ENCODING,
			'S_HIDDEN_FORMFIELDS'			=> $S_HIDDEN_FORMFIELDS,
			'S_POST_ACTION'					=> $S_POST_ACTION,
			'SITE_DESCRIPTION'				=> BOT_SITE_DESC,
			'SITENAME'							=> BOT_SITE_NAME,
			'SPECIAL_LAN_CHK'					=> $SPECIAL_LAN_CHK,
			'SPECIAL_LAN_KEY'					=> $SPECIAL_LAN_KEY[ $_LANG ],
			'SPECIAL_LAN_TITLE'				=> $SPECIAL_LAN_TITLE[ $_LANG ],
			'SSH_IN_CHK'						=> $SSH_IN_CHK,
			'SSH_IN_DISABLED'					=> $SSH_IN_DISABLED,
			'SSH_IN_KEY'						=> $SSH_IN_KEY[ $_LANG ],
			'SSH_IN_TITLE'						=> $SSH_IN_TITLE[ $_LANG ],
			'SSH_IN_STYLE'						=> $SSH_IN_STYLE,
			'SSH_OUT_CHK'						=> $SSH_OUT_CHK,
			'SSH_OUT_DISABLED'				=> $SSH_OUT_DISABLED,
			'SSH_OUT_KEY'						=> $SSH_OUT_KEY[ $_LANG ],
			'SSH_OUT_TITLE'					=> $SSH_OUT_TITLE[ $_LANG ],
			'SSH_OUT_STYLE'					=> $SSH_OUT_STYLE,
			'STATD_PORT'						=> $STATD_PORT,
			'STATD_PORT_DISABLED'			=> $STATD_PORT_DISABLED,
			'STATD_PORT_KEY'					=> $STATD_PORT_KEY[ $_LANG ],
			'STATD_PORT_TITLE'				=> $STATD_PORT_TITLE[ $_LANG ],
			'STATD_PORT_STYLE'				=> $STATD_PORT_STYLE,
			'SUBMIT_KEY'						=> $SUBMIT_KEY[ $_LANG ],
			'SUBMIT_TITLE'						=> $SUBMIT_TITLE,
			'T_BODY_BGCOLOR'					=> T_BODY_BGCOLOR,
			'T_BODY_LINK'						=> T_BODY_LINK,
			'T_BODY_TEXT'						=> T_BODY_TEXT,
			'T_BODY_VLINK'						=> T_BODY_VLINK,
			'TELNET_OUT_CHK'					=> $TELNET_OUT_CHK,
			'TELNET_OUT_DISABLED'			=> $TELNET_OUT_DISABLED,
			'TELNET_OUT_KEY'					=> $TELNET_OUT_KEY[ $_LANG ],
			'TELNET_OUT_TITLE'				=> $TELNET_OUT_TITLE[ $_LANG ],
			'TELNET_OUT_STYLE'				=> $TELNET_OUT_STYLE,
			'TOPIC_TITLE'						=> $TOPIC_TITLE[ $_LANG ],
			'TRANSPARENT_PROXY_CHK'			=> $TRANSPARENT_PROXY_CHK,
			'TRANSPARENT_PROXY_DISABLED'	=> $TRANSPARENT_PROXY_DISABLED,
			'TRANSPARENT_PROXY_KEY'			=> $TRANSPARENT_PROXY_KEY[ $_LANG ],
			'TRANSPARENT_PROXY_TITLE'		=> $TRANSPARENT_PROXY_TITLE[ $_LANG ],
			'TRANSPARENT_PROXY_STYLE'		=> $TRANSPARENT_PROXY_STYLE,
			'TTL'									=> $TTL,
			'TTL_DISABLED'						=> $TTL_DISABLED,
			'TTL_KEY'							=> $TTL_KEY[ $_LANG ],
			'TTL_TITLE'							=> $TTL_TITLE[ $_LANG ],
			'TTL_STYLE'							=> $TTL_STYLE,
			'U_BLOCK_OUTBOUND'				=> $U_BLOCK_OUTBOUND,
			'U_DNS_IN'							=> $U_DNS_IN,
			'U_DYNAMIC_IP'						=> $U_DYNAMIC_IP,
			'U_FAVICON'							=> U_FAVICON,
			'U_GATEWAY'							=> $U_GATEWAY,
			'U_IM_PORT_TO'						=> $U_IM_PORT_TO,
			'U_INBOUND_ALLOW'					=> $U_INBOUND_ALLOW,
			'U_INDEX'							=> U_INDEX,
			'U_INET_ADDRESS'					=> $U_INET_ADDRESS,
			'U_INET_IFACE'						=> $U_INET_IFACE,
			'U_INTERNAL_DHCP'					=> $U_INTERNAL_DHCP,
			'U_IRC_USER'						=> $U_IRC_USER,
			'U_LOCAL_BCAST'					=> $U_LOCAL_BCAST,
			'U_LOCAL_IFACE'					=> $U_LOCAL_IFACE,
			'U_LOCAL_IP'						=> $U_LOCAL_IP,
			'U_LOCAL_NET'						=> $U_LOCAL_NET,
			'U_LOG_FIREPARSE'					=> $U_LOG_FIREPARSE,
			'U_LOGO'								=> U_LOGO,
			'U_MSN_PORT_TO'					=> $U_MSN_PORT_TO,
			'U_MDNSRESPONDER_IN'				=> $U_MDNSRESPONDER_IN,
			'U_OTHER_IN'						=> $U_OTHER_IN,
			'U_PASSIVE_PORT_TO'				=> $U_PASSIVE_PORT_TO,
			'U_PORT_FORWARD'					=> $U_PORT_FORWARD,
			'U_PORT_FORWARD_REDIR'			=> $U_PORT_FORWARD_REDIR,
			'U_REDIRECT_PORT'					=> $U_REDIRECT_PORT,
			'U_RQUOTAD_PORT'					=> $U_RQUOTAD_PORT,
			'U_SPECIAL_LAN'					=> $U_SPECIAL_LAN,
			'U_STYLE'							=> U_STYLE,
			'U_TTL'								=> $U_TTL,
			'U_VIEW_TOPIC'						=> $U_VIEW_TOPIC,
			'YEAR_NOW'							=> $YEAR_NOW
		));
	}	// if( !$downloadFW )
// -------------- End   of Display Section ----------------
// -------------- Start of Common-bottom section-----------
	$conteg_param['charset']			= $S_CONTENT_ENCODING;
	$conteg_param['modified']			= $MODIFIED;
	$conteg_param['lang']				= $_LANG;

	if( $downloadFW ) {	// download the firewall script
		$conteg_param['cache_control']['macro']	= 'download';
		$conteg_param['filename']						= 'iptables';
		include ( BOT_LANG_DIR ."/$_LANG/efg_firewall.inc");
	} else {					// supply the EFG web utility
		$Template->pparse('body');
	}

	$_Encode->setup( $conteg_param );
	$_Encode->show();
// -------------- End of Common-bottom section-------------
// vi: shiftwidth=3 tabstop=3 et
?>